<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Banner
  {

   function __construct() { }

   public static function getBannerFieldsArray()
    {
     return array('bannerID','title','banner_type','banner','enabled','languageID','ts');
    }

   public static function getBannerExchangeFieldsArray()
    {
     return array('bannerID','title','userID',
	              'banner_source','banner_from_remote','banner_image','banner_from_local','impressions','banner_from_external','banner_url',
				  'banner_alt','enabled','languageID','clicks','ts');
    }

   public static function getBannerExchangeCreditFieldsArray()
    {
     return array('banner_exchange_creditID','userID','credits','unlimited_credits','ts');
    }

   public static function executeUserAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_BANNER_EXCHANGE:
        {
         return wm3Banner::addBannerExchange($w3,0,true);
         break;
        }
	   case WM3_cACTION_SAVE_BANNER_EXCHANGE:
        {
         $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_banners_exchange         WRITE,
	                                         ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits WRITE,
								             ".WM3_cCONFIG_DB_PREFIX."_users                    WRITE");
         $error = wm3Banner::checkBannerExchangeError($w3,true);
         if(!$error) {
                      $lastID = wm3Banner::saveBannerExchange($w3,true);
                      $w3->getDBObj()->query("UNLOCK TABLES");
                      return wm3Banner::getBannerExchangeList($w3,$lastID,true,true);
                     }
         else        {
			          $w3->getDBObj()->query("UNLOCK TABLES");
			          return wm3Banner::addBannerExchange($w3,$error,true);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_BANNER_EXCHANGE:
        {
         wm3Banner::disableBannerExchange($w3,$w3->getVariable('bannerID','get'),true);
         return wm3Banner::getBannerExchangeList($w3,$w3->getVariable('bannerID','get'),true,true);
         break;
        }
       case WM3_cACTION_ENABLE_BANNER_EXCHANGE:
        {
         wm3Banner::enableBannerExchange($w3,$w3->getVariable('bannerID','get'),true);
         return wm3Banner::getBannerExchangeList($w3,$w3->getVariable('bannerID','get'),true,true);
         break;
        }
       case WM3_cACTION_DELETE_BANNER_EXCHANGE:
        {
         wm3Banner::deleteBannerExchange($w3,$w3->getVariable('bannerID','get'),true);
         return wm3Banner::getBannerExchangeList($w3,0,true,true);
         break;
        }
       case WM3_cACTION_CODE_BANNER_EXCHANGE:
        {
         return wm3Banner::makeBannerExchangeCode($w3);
         break;
        }
       case WM3_cACTION_STATISTICS_BANNER_EXCHANGE:
        {
         return wm3Banner::makeBannerExchangeStatistics($w3);
         break;
        }
       default:
        {
         return wm3Banner::getBannerExchangeList($w3,0,true,true);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_BANNER:
        {
         wm3Banner::disableBanner($w3,$w3->getVariable('bannerID','get'));
         return wm3Banner::getBannerList($w3,$w3->getVariable('bannerID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_BANNER:
        {
         wm3Banner::enableBanner($w3,$w3->getVariable('bannerID','get'));
         return wm3Banner::getBannerList($w3,$w3->getVariable('bannerID','get'));
         break;
        }
       case WM3_cACTION_DELETE_BANNER:
        {
         wm3Banner::deleteBanner($w3,$w3->getVariable('bannerID','get'));
         return wm3Banner::getBannerList($w3);
         break;
        }
       case WM3_cACTION_ADD_BANNER:
        {
         return wm3Banner::addBanner($w3);
         break;
        }
       case WM3_cACTION_EDIT_BANNER:
        {
         return wm3Banner::editBanner($w3);
         break;
        }
       case WM3_cACTION_ACTIVATE_BANNER:
        {
         $lastID = wm3Banner::activateBanner($w3);
         // $msg= banner activate ... //TODO
         return wm3Banner::getBannerList($w3,$lastID);
         break;
        }
       case WM3_cACTION_DEACTIVATE_BANNER:
        {
         $lastID = wm3Banner::deactivateBanner($w3);
         // $msg= banner activate ... //TODO
         return wm3Banner::getBannerList($w3,$lastID);
         break;
        }
       case WM3_cACTION_DUPLICATE_BANNER:
        {
         $lastID = wm3Banner::duplicateBanner($w3);
         // $msg= banner duplicated... //TODO
         return wm3Banner::getBannerList($w3,$lastID);
         break;
        }
       case WM3_cACTION_DISABLE_BANNER_EXCHANGE:
        {
         wm3Banner::disableBannerExchange($w3,$w3->getVariable('bannerID','get'));
         return wm3Banner::getBannerExchangeList($w3,$w3->getVariable('bannerID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_BANNER_EXCHANGE:
        {
         wm3Banner::enableBannerExchange($w3,$w3->getVariable('bannerID','get'));
         return wm3Banner::getBannerExchangeList($w3,$w3->getVariable('bannerID','get'));
         break;
        }
       case WM3_cACTION_DELETE_BANNER_EXCHANGE:
        {
         wm3Banner::deleteBannerExchange($w3,$w3->getVariable('bannerID','get'));
         return wm3Banner::getBannerExchangeList($w3);
         break;
        }
       case WM3_cACTION_ADD_BANNER_EXCHANGE:
        {
         return wm3Banner::addBannerExchange($w3);
         break;
        }
       case WM3_cACTION_SAVE_BANNER_EXCHANGE:
        {
         $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_banners_exchange         WRITE,
	                                         ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits WRITE,
									         ".WM3_cCONFIG_DB_PREFIX."_users                    WRITE");
         $error = wm3Banner::checkBannerExchangeError($w3);
         if(!$error) {
                      $lastID = wm3Banner::saveBannerExchange($w3);
                      $w3->getDBObj()->query("UNLOCK TABLES");
                      return wm3Banner::getBannerExchangeList($w3,$lastID);
                     }
         else        {
			          $w3->getDBObj()->query("UNLOCK TABLES");
			          return wm3Banner::addBannerExchange($w3,$error);
		             }
         break;
        }
       case WM3_cACTION_EDIT_BANNER_EXCHANGE:
        {
         return wm3Banner::editBannerExchange($w3);
         break;
        }
       case WM3_cACTION_UPDATE_BANNER_EXCHANGE:
        {
         $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_banners_exchange         WRITE,
	                                         ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits WRITE,
								             ".WM3_cCONFIG_DB_PREFIX."_users                    WRITE");
         $error = wm3Banner::checkBannerExchangeError($w3);
         if(!$error) {
                      $lastID = wm3Banner::updateBannerExchange($w3);
                      $w3->getDBObj()->query("UNLOCK TABLES");
                      return wm3Banner::getBannerExchangeList($w3,$lastID);
                     }
         else        {
			          $w3->getDBObj()->query("UNLOCK TABLES");
			          return wm3Banner::editBannerExchange($w3,$error);
		             }
         break;
        }
	   case WM3_cACTION_SHOW_BANNER_EXCHANGE_CREDIT:
	    {
		 return wm3Banner::getBannerExchangeUserCreditList($w3);
		 break;
		}
	   case WM3_cACTION_UPDATE_BANNER_EXCHANGE_CREDIT:
	    {
		 wm3Banner::updateBannerExchangeCredits($w3,$w3->getVariable('userID','post'));
		 return wm3Banner::getBannerExchangeUserCreditList($w3,$w3->getVariable('userID','post'));
		 break;
		}
	   case WM3_cACTION_ENABLE_BANNER_EXCHANGE_UNLIMITED_CREDIT:
	    {
		 wm3Banner::enableBannerExchangeUnlimitedCredits($w3,$w3->getVariable('userID','get'));
         return wm3Banner::getBannerExchangeUserCreditList($w3,$w3->getVariable('userID','get'));
		 break;
		}
	   case WM3_cACTION_DISABLE_BANNER_EXCHANGE_UNLIMITED_CREDIT:
	    {
		 wm3Banner::disableBannerExchangeUnlimitedCredits($w3,$w3->getVariable('userID','get'));
         return wm3Banner::getBannerExchangeUserCreditList($w3,$w3->getVariable('userID','get'));
		 break;
		}
       case WM3_cACTION_SHOW_BANNER_EXCHANGE:
        {
         return wm3Banner::getBannerExchangeList($w3);
         break;
        }
       default:
        {
         return wm3Banner::getBannerList($w3);
        }
      }     
    }

   public static function getBannerExchangeUserCreditList($w3,$currentID = 0,$admin = true)
    {
     // Get banners exchange users credits list

     // Prepare variables to create the list
     $max_page_items = 12;
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE login LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
	 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_BANNER_EXCHANGE_CREDIT;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY login";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'userID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&userID=$row->userID"; 
	   $_ARRAY = wm3Banner::getBannerExchangeTotalCredits($w3,$row->userID,0,true);
	   $credits = $_ARRAY['credits'];
	   $userID = $row->userID;
	   if($_ARRAY['unlimited_credits']) $unlimited_credits = "<i>Unlimited credits its active</i>";
	   else                             $unlimited_credits = "";
	   require(WM3_cPATH_INCLUDE."admin_banner_exchange_credit_form.inc");
       $_DATA[$p]->login = "<b>$row->login</b><br>($row->name $row->surname)";
       $_DATA[$p]->info  = "$credits available credits<br>$unlimited_credits";
       $_DATA[$p]->form  = $content;
       // Buttons
       if($unlimited_credits) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_BANNER_EXCHANGE_UNLIMITED_CREDIT,"action_disable.png",$w3->getWord(180)." unlimited credits");
       else                   $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_BANNER_EXCHANGE_UNLIMITED_CREDIT,"action_enable.png",$w3->getWord(181)." unlimited credits");
       if($row->userID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1022));
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_banner_search_form.inc');
     $list->setSearchForm($search_form);
	 if($found) $list->setCurrentID($currentID);
	 $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_BANNER_EXCHANGE_CREDIT.$id_link.$search_link);
     if($admin) {
                 $list->setCaptionLabels(array($w3->getWord(373),$w3->getWord(1317)));
                 $list->setCaptionWidths(array(25,35,40));
                 $list->setCaptionColspan(array(1,2,1));
                 $list->setWidths(array(25,35,40));
			    }
     else       {
		         $list->setRenderCaption(false);
                 $list->setWidths(array(100));
                }
     return $list->render();
    }

   public static function updateBannerExchangeCredits($w3,$userID)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_banners_exchange         WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits WRITE,
				                         ".WM3_cCONFIG_DB_PREFIX."_users                    WRITE");
     $_FIELD = webmatic3::getPostValueArray(wm3Banner::getBannerExchangeCreditFieldsArray(),WM3_cQUOTE_DB);
     wm3Banner::saveBannerExchangeCredits($w3,$userID);
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits SET credits = '".$_FIELD['credits']."' WHERE userID = '$userID'");
	 $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function enableBannerExchangeUnlimitedCredits($w3,$userID)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_banners_exchange   WRITE,
                                   ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_users                    WRITE");
     wm3Banner::saveBannerExchangeCredits($w3,$userID);
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits SET unlimited_credits = '".WM3_cENABLED."' WHERE userID = '$userID'");
	 $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function disableBannerExchangeUnlimitedCredits($w3,$userID)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_banners_exchange         WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits WRITE,
								         ".WM3_cCONFIG_DB_PREFIX."_users                    WRITE");
     wm3Banner::saveBannerExchangeCredits($w3,$userID);
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits SET unlimited_credits = '".WM3_cDISABLED."' WHERE userID = '$userID'");
	 $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function getBannerList($w3,$currentID = 0,$admin = true)
    {
     // Get banners list (admin side)

     // Prepare variables to create the list
     $max_page_items = 6;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE banner LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     if(!$admin)
      {
       if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
       $query_filter .= "enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'";
      }
     $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_BANNERS;
     $id_link = '';

     // Do the query and take the total items number
     $order_by = " ORDER BY title";
	 $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_banners $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'bannerID',$rs);
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&bannerID=$row->bannerID";
       if($admin) $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" valign=\"middle\">";
       if($allowed) $allowed_link = $base_allowed_link."&bannerID=$row->bannerID";
       $_DATA[$p]->title = "<b>$row->title</b> $lang_flag<br>$row->banner";
       if($admin)
        {
         $active_info = wm3Banner::makeBannerLegend($w3,$link,$row->bannerID);
         $_DATA[$p]->info = $active_info;
         // Buttons
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_BANNER,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_BANNER,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_BANNER,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_DUPLICATE_BANNER,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416));
         $_DATA[$p]->b4 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_BANNER,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_BANNER,"action_edit.png",$w3->getWord(178));
        }
       if($row->bannerID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     if($admin) {
		         require(WM3_cPATH_INCLUDE.'admin_banner_search_form.inc');
		         $list->setSearchForm($search_form);
		         $list->setTitle($w3->getWord(579));
		         if($found) $list->setCurrentID($currentID);
		         $list->setMaxPageItems($max_page_items);
                 $list->setPage($pg);
                 $list->setPagesNavigatorLink($base_link.$id_link.$search_link);
                 $list->setCaptionLabels(array($w3->getWord(228),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(70,30));
                 $list->setCaptionColspan(array(1,1,4));
                 $list->setWidths(array(70,30));
			    }
     return $list->render();
    }

   public static function addBanner($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Banner::getBannerFieldsArray());
	 $action = WM3_cACTION_ADD_BANNER;
	 require(WM3_cPATH_INCLUDE.'admin_banner_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(345));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3Banner::saveBanner($w3);
         return wm3Banner::getBannerList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function editBanner($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_BANNER;
	 require(WM3_cPATH_INCLUDE.'admin_banner_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(100));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_banners
                               WHERE bannerID = '".$w3->getVariable('bannerID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Banner::getBannerFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Banner::getBannerFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3Banner::updateBanner($w3);
         return wm3Banner::getBannerList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function saveBanner($w3)
    {
     $_FIELD       = webmatic3::getPostValueArray(wm3Banner::getBannerFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_banners',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateBanner($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Banner::getBannerFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners
                       SET   title       = '".$_FIELD['title']."',
					         banner_type = '".$_FIELD['banner_type']."',
                             banner      = '".$_FIELD['banner']."',
                             enabled     = '".$_FIELD['enabled']."',
                             languageID  = '".$_FIELD['languageID']."'
                       WHERE bannerID    = '".$_FIELD['bannerID']."'");
     return $_FIELD['bannerID'];
    }

   public static function duplicateBanner($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_banners
                             WHERE bannerID = '".$w3->getVariable('bannerID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Banner::getBannerFieldsArray(),$row,WM3_cQUOTE_DB);
       $_FIELD['title']   = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['ts']      = time();
       $w3->getDBObj()->saveAllTableFields('_banners',$_FIELD);
       return $w3->getDBObj()->getLastInsertID();
      }
    }

   public static function activateBanner($w3)
    {
     wm3Preferences::setPreferencesBanner($w3,$w3->getVariable('positionID','get'),$w3->getVariable('bannerID','get'));
     $w3->setPreferences($w3);
     return $w3->getVariable('bannerID','get');
    }
   
   public static function deactivateBanner($w3)
    {
     wm3Preferences::setPreferencesBanner($w3,$w3->getVariable('positionID','get'),'0');
     $w3->setPreferences($w3);
     return $w3->getVariable('bannerID','get');
    }

   public static function disableBanner($w3,$bannerID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners SET enabled = '".WM3_cDISABLED."' WHERE bannerID = '$bannerID'");
	}

   public static function enableBanner($w3,$bannerID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners SET enabled = '".WM3_cENABLED."' WHERE bannerID = '$bannerID'");
	}
   
   public static function deleteBanner($w3,$bannerID)
    {
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_banners WHERE bannerID = '$bannerID'");
	}

   public static function getBannerExchangeList($w3,$currentID = 0,$admin = true,$user = false)
    {
     // Get banners exchange list (admin side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_BANNERS); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE title LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     if(!$admin)
      {
       if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
       $query_filter .= "enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'";
      }
	 if(!$user) $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_BANNER_EXCHANGE;
	 else       $search_form_link = WM3_cCONFIG_USER_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_BANNERS;
     $id_link = '';
     if($user)
      {
       if($query_filter) $query_filter .= " AND userID = '".$w3->getAuthenticateUserID()."'";
       else              $query_filter .= " WHERE userID = '".$w3->getAuthenticateUserID()."'";
      }

     // Do the query and take the total items number
	 $order_by = " ORDER BY title";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_banners_exchange $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'bannerID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&bannerID=$row->bannerID";
       if($allowed) $allowed_link = $base_allowed_link."&bannerID=$row->bannerID";
       $banner = wm3Banner::makeBannerExchange($w3,$row);
       $_DATA[$p]->banner = $banner;
       if($admin)
        {
		 $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" valign=\"middle\">";
		 if($row->impressions > 0) $click_through = $row->clicks/$row->impressions*100; else $click_through = 0;
		 $info = "$lang_flag <b>".wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."</b><br>
		          ".$w3->getWord(1227).": $row->impressions - Clicks: $row->clicks<br>
				  <nobr>Click through: ".wm3Util::makePercentageBar($w3,$click_through,150,10)." ".round($click_through,4)."%</nobr>";
         $_DATA[$p]->info = $info;

         // Buttons
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_BANNER_EXCHANGE,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_BANNER_EXCHANGE,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_BANNER_EXCHANGE,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_BANNER_EXCHANGE,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_BANNER,"action_edit.png",$w3->getWord(178));
        }
       if($row->bannerID == $currentID && !$found) { $currentID = $p; $found = true; }       
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     if($admin) {
		         require(WM3_cPATH_INCLUDE.'admin_banner_search_form.inc');
		         $list->setSearchForm($search_form);
                 if(!$user) $list->setTitle($w3->getWord(1233));
	             else       $list->setTitle($w3->getWord(1313));
		         if($found) $list->setCurrentID($currentID);
		         $list->setMaxPageItems($max_page_items);
                 $list->setPage($pg);
                 $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_BANNER_EXCHANGE.$id_link.$search_link);
                 $list->setCaptionLabels(array($w3->getWord(228),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(70,30));
                 $list->setCaptionColspan(array(1,1,3));
                 $list->setWidths(array(70,30));
			    }
	 else       {
		         $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_BANNER_EXCHANGE.$id_link.$search_link);
		        }
     return $list->render();
    }

   public static function checkBannerExchangeError($w3,$user = false)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Banner::getBannerExchangeFieldsArray());

     $aux = time()."_".rand(1,99999);
     if($_FIELD['title']=='') return 7;
     if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_LOCAL) // Take file from local hard drive
      {
       // Upload the file and give the name to the files
       if($_FILES['banner_from_local']['name']) $banner_name = $aux.".".wm3Util::cutExtension($_FILES['banner_from_local']['name']);
       else                                     $banner_name = "";
       $error = wm3Folder::uploadFile("banner_from_local",WM3_cPATH_BANNERS,$banner_name,true,wm3Folder::mimeTypeImage(),0);
       if($error) return $error;
      }
     if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_URL) if(!wm3Util::isURL($_FIELD['banner_from_external'])) return 8; // External link
	 if(!wm3Util::isURL($_FIELD['banner_url'])) return 9;
     return 0;
    }

   public static function addBannerExchange($w3,$error = 0,$user = false)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Banner::getBannerExchangeFieldsArray());
	 $action = WM3_cACTION_SAVE_BANNER_EXCHANGE;
     if($user) require(WM3_cPATH_INCLUDE.'user_banner_exchange_form.inc');
	 else      require(WM3_cPATH_INCLUDE.'admin_banner_exchange_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(345));
     $form->setFieldsValues($_FIELD);

     if($error)
      {
       // Delete bad uploaded files (if exists)
       if(file_exists(WM3_cPATH_BANNERS.$_FILES['banner_from_local']['name'])) @unlink(WM3_cPATH_BANNERS.$_FILES['banner_from_local']['name']);
       $form->setError(true);
      }
     switch($error)
      {
       // File upload error
       case 1: // Upload error
        {
         $_F['banner_from_local']->setError(true);
         $form->setTitle("Upload error $error");
         break;
        }
       case 2: // File not allowed
        {
         $_F['banner_from_local']->setError(true);
         $form->setTitle("Not allowed $error");
         break;
        }
       case 3: // File already exist error
        {
         $_F['banner_from_local']->setError(true);
         $form->setTitle("File already exist (check overwrite box) $error");
         break;
        }
       case 5: // File too big
        {
         $_F['banner_from_local']->setError(true);
         $form->setTitle("File too big $error");
         break;
        }
       case 6: // Empty file given (no upload performed)
        {
         $_F['banner_from_local']->setError(true);
         $form->setTitle("Empty file name $error");
         break;
        }	   
	   // Other errors
       case 7: // Empty title
        {
         $_F['title']->setError(true);
         $form->setTitle($w3->getWord(8));
         break;
        }
       case 8: // Invalid banner image (if external)
        {
         $_F['banner_from_external']->setError(true);
         $form->setTitle("Invalid banner image");
         break;
        }
	   case 9: // Invalid banner url 
        {
         $_F['banner_url']->setError(true);
         $form->setTitle("Invalid banner URL");
         break;
        }
       default:
        {
         // Default values for the form
         $_F['enabled']->setValue(WM3_cENABLED);
       	}
      }

     // Operation to do before render the form
     $preview_image = $_FIELD['banner_from_remote']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_BANNERS); // Set due preview image
     $_F['banner_from_remote']->setExtraContentAfter("<br>".wm3Util::renderImg($preview_image,$w3->getWord(893),464,60,WM3_cPATH_BANNERS,1,'top','preview_image'));
	 if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_LOCAL)  $_F['banner_from_local']->setVisible(true);
	 if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_REMOTE) $_F['banner_from_remote']->setVisible(true);
	 if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_URL)    $_F['banner_from_external']->setVisible(true);

     return $form->render();
    }

   public static function editBannerExchange($w3,$error = 0)
    {
	 // Initialize form
	 $action = WM3_cACTION_UPDATE_BANNER_EXCHANGE;
     require(WM3_cPATH_INCLUDE.'admin_banner_exchange_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(345));

     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                               WHERE bannerID = '".$w3->getVariable('bannerID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Banner::getBannerExchangeFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else
      {
	   $_FIELD = webmatic3::getPostValueArray(wm3Banner::getBannerExchangeFieldsArray());
       $form->setError(true);
      }
     $form->setFieldsValues($_FIELD);

     switch($error)
      {
       // File upload error
       case 1: // Upload error
        {
         $_F['banner_from_local']->setError(true);
         $form->setTitle("Upload error $error");
         break;
        }
       case 2: // File not allowed
        {
         $_F['banner_from_local']->setError(true);
         $form->setTitle("Not allowed $error");
         break;
        }
       case 3: // File already exist error
        {
         $_F['banner_from_local']->setError(true);
         $form->setTitle("File already exist (check overwrite box) $error");
         break;
        }
       case 5: // File too big
        {
         $_F['banner_from_local']->setError(true);
         $form->setTitle("File too big $error");
         break;
        }
       case 6: // Empty file given (no upload performed)
        {
         $_F['banner_from_local']->setError(true);
         $form->setTitle("Empty file name $error");
         break;
        }	   
	   // Other errors
       case 7: // Empty title
        {
         $_F['title']->setError(true);
         $form->setTitle($w3->getWord(8));
         break;
        }
       case 8: // Invalid banner image (if external)
        {
         $_F['banner_from_external']->setError(true);
         $form->setTitle("Invalid banner image");
         break;
        }
	   case 9: // Invalid banner url 
        {
         $_F['banner_url']->setError(true);
         $form->setTitle("Invalid banner URL");
         break;
        }
       default:
        {
         $_FIELD['banner_from_local'] = $_FIELD['banner_from_remote'] = $_FIELD['banner_from_external'] = '';
         if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_REMOTE) $_F['banner_from_remote']->setValue($_FIELD['banner_image']);
	     if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_URL)    $_F['banner_from_external']->setValue($_FIELD['banner_image']);
       	}
      }

     // Operation to do before render the form
     $preview_image = $_F['banner_from_remote']->getValue();
     $_F['banner_from_remote']->setExtraContentAfter("<br>".wm3Util::renderImg($preview_image,$w3->getWord(893),464,60,WM3_cPATH_BANNERS,1,'top','preview_image'));
	 if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_LOCAL)  $_F['banner_from_local']->setVisible(true);
	 if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_REMOTE) $_F['banner_from_remote']->setVisible(true);
	 if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_URL)    $_F['banner_from_external']->setVisible(true);

     return $form->render();
    }

   public static function saveBannerExchange($w3,$user = false)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Banner::getBannerExchangeFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['banner_image'] = $_FILES['banner_from_local']['name'];
     if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['banner_image'] = $_FIELD['banner_from_remote'];
     if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['banner_image'] = $_FIELD['banner_from_external'];
     if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['banner_source'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "banner_source" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     $_FIELD['ts'] = time();
	 if($user) $_FIELD['userID'] = $w3->getAuthenticateUserID();
     $w3->getDBObj()->saveAllTableFields('_banners_exchange',$_FIELD,array('banner_from_local','banner_from_remote','banner_from_external'));
	 $lastID = $w3->getDBObj()->getLastInsertID();
	 wm3Banner::saveBannerExchangeCredits($w3,$_FIELD['userID']);
     return $lastID;
    }

   public static function updateBannerExchange($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Banner::getBannerExchangeFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['banner_image'] = $_FILES['banner_from_local']['name'];
     if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['banner_image'] = $_FIELD['banner_from_remote'];
     if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['banner_image'] = $_FIELD['banner_from_external'];
     if($_FIELD['banner_source'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['banner_source'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "banner_source" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                       SET   title             = '".$_FIELD['title']."',
                             userID            = '".$_FIELD['userID']."',
							 banner_source     = '".$_FIELD['banner_source']."',
							 banner_image      = '".$_FIELD['banner_image']."',
							 banner_url        = '".$_FIELD['banner_url']."',
							 banner_alt        = '".$_FIELD['banner_alt']."',
                             enabled           = '".$_FIELD['enabled']."',
                             languageID        = '".$_FIELD['languageID']."'
                       WHERE bannerID          = '".$_FIELD['bannerID']."'");
     wm3Banner::saveBannerExchangeCredits($w3,$_FIELD['userID']);
     return $_FIELD['bannerID'];
    }

   public static function saveBannerExchangeCredits($w3,$userID)
    {
	 // Check if exist a row in banners exchange credits table for an user (if not insert a row)
	 if(!wm3User::existUser($w3,$userID)) return;
	 $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits WHERE userID = '$userID'");
     if($w3->getDBObj()->totalRows($rs) == 0)
	  {
	   $_FIELD = webmatic3::getPostValueArray(wm3Banner::getBannerExchangeCreditFieldsArray(),WM3_cQUOTE_DB);
	   $_FIELD['userID']            = $userID;
	   $_FIELD['credits']           = $w3->getPreferences('banners_exchange_starting_credits');
	   $_FIELD['unlimited_credits'] = WM3_cDISABLED;
	   $_FIELD['ts']                = time();
	   $w3->getDBObj()->saveAllTableFields('_banners_exchange_credits',$_FIELD);
      }
    }

   public static function disableBannerExchange($w3,$bannerID,$user = false)
    {
	 if($user) $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange SET enabled = '".WM3_cDISABLED."' WHERE bannerID = '$bannerID' AND userID='".$w3->getAuthenticateUserID()."'");
	 else      $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange SET enabled = '".WM3_cDISABLED."' WHERE bannerID = '$bannerID'");
	}

   public static function enableBannerExchange($w3,$bannerID,$user = false)
    {
	 if($user) $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange SET enabled = '".WM3_cENABLED."' WHERE bannerID = '$bannerID' AND userID='".$w3->getAuthenticateUserID()."'");
	 else      $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange SET enabled = '".WM3_cENABLED."' WHERE bannerID = '$bannerID'");
	}
   
   public static function deleteBannerExchange($w3,$bannerID,$user = false)
    {
	 if($user) $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_banners_exchange WHERE bannerID = '$bannerID' AND userID='".$w3->getAuthenticateUserID()."'");
	 else      $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_banners_exchange WHERE bannerID = '$bannerID'");
	}

   public static function renderBanner($w3,$bannerID,$positionID,$left_empty,$right_empty)
    {
     // Do not render banners if are off
     if(!$w3->getPreferences('banners_enabled')) return "";

     // Do not render banners if bannerID its 0
     if($bannerID == 0) return '';
     
     // Do not render banners for admin/chat stage
     if($w3->getStage() == WM3_cSTAGE_ADMIN ||
	    $w3->getStage() == WM3_cSTAGE_CHAT) return '';

     // Do not render banners panel and bottom banners for user stage
     if($w3->getStage() == WM3_cSTAGE_USER && $positionID >= 3) return "";

     // Do not render banners if left panels are empty
     if($positionID >= 7 && $positionID <= 9)
      if($left_empty) return '';

     // Do not render banners if right panels are empty
     if($positionID >= 3 && $positionID <= 5)
      if($right_empty) return '';

     // Take banner from database
     if($positionID == 1 && $w3->getPreferences('banners_exchange_enabled')) // Banner exchange (rotational) its enabled
	  {
	   $banner_exchange = wm3Banner::renderBannerExchange($w3,true);
	   if($banner_exchange) return $banner_exchange;
	  }

	 // Normal banner
     $rs = $w3->getDBObj()->query("SELECT banner
                             FROM   ".WM3_cCONFIG_DB_PREFIX."_banners
                             WHERE   bannerID = '$bannerID'");
     if($w3->getDBObj()->totalRows($rs) != 1 ) return "";
     $row = $w3->getDBObj()->fetch($rs);
     return $row->banner;
    }

   public static function renderBannerExchange($w3,$extern = false,$extra = false)
    {
     // Take a random banner from database
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_banners_exchange         WRITE,
	                                     ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits WRITE");
     $rs = $w3->getDBObj()->query("SELECT ".WM3_cCONFIG_DB_PREFIX."_banners_exchange.*,
	                                ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits.*
                               FROM ".WM3_cCONFIG_DB_PREFIX."_banners_exchange,
							        ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits
                              WHERE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange.userID = ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits.userID
							    AND (".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits.credits > 0 OR ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits.unlimited_credits = '".WM3_cENABLED."')
								AND ".WM3_cCONFIG_DB_PREFIX."_banners_exchange.enabled = '".WM3_cENABLED."'
								AND (".WM3_cCONFIG_DB_PREFIX."_banners_exchange.languageID = '".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_banners_exchange.languageID = '".WM3_cLANGUAGE_ALL."')
                              GROUP BY bannerID
							  ORDER BY RAND() LIMIT 1");
     if($w3->getDBObj()->totalRows($rs) != 1 ) { $w3->getDBObj()->query("UNLOCK TABLES"); return ""; }

	 $row = $w3->getDBObj()->fetch($rs);
     if($row->unlimited_credits) $n = 0; else $n = 1;
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange SET impressions = impressions + 1 WHERE bannerID = '$row->bannerID'");
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits SET credits = credits - $n WHERE userID = '$row->userID' AND credits > 0");
	 $w3->getDBObj()->query("UNLOCK TABLES");
     return wm3Banner::makeBannerExchange($w3,$row,0,$extern,$extra);
    }

   public static function clickBannerExchange($w3)
    {
     // Banner exchange clicked
	 //TODO fare lock table??? è utile qui??? e' necessario qui???
	 $bannerID = $w3->getVariable('bannerID','get');
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                             WHERE bannerID = '$bannerID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return false;
	 $row = $w3->getDBObj()->fetch($rs);

	 if(wm3Session::bannerExchangeAllowed($w3,$bannerID,WM3_cSESSION_CLICK))
	  {
	   wm3Session::bannerExchangeProtect($w3,$bannerID,WM3_cSESSION_CLICK);
  	   $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits SET credits = credits + ".$w3->getPreferences('banners_exchange_ratio')." WHERE userID = '$row->userID' AND unlimited_credits = '".WM3_cDISABLED."'");
	   $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange SET clicks = clicks + 1 WHERE bannerID = '$row->bannerID'");
      }
	 header("Location: $row->banner_url"); // Redirect to banner link
     die;
    }

   public static function makeBannerLegend($w3,$link,$bannerID)
    {
     // Create banners legend for a single banner
     for($i = 1; $i <= 9; $i++)
      {
       $field = "banner".$i."ID";
       if($w3->getPreferences($field) == $bannerID) $_B[$i] = wm3Util::actionButton("$link&positionID=$i&action=".WM3_cACTION_DEACTIVATE_BANNER,"action_deactivate.png","",""," $i",0,10,10);
       else                                         $_B[$i] = wm3Util::actionButton("$link&positionID=$i&action=".WM3_cACTION_ACTIVATE_BANNER,"action_activate.png","",""," $i",0,10,10);
      }

     $str = "<table bgcolor=\"#ffffff\" celspadding=\"0\" cellspacing=\"2\" border=\"0\" style=\"border: navy 1px solid; border-color: #000000;\">
              <tr>
               <td bgcolor=\"#55ddff\" style=\"border: navy 1px solid; border-color: #000000;\">&nbsp;&nbsp;</td>
               <td bgcolor=\"#dddddd\" style=\"border: navy 1px solid; border-color: #000000;\">$_B[1](rot)</td>
               <td bgcolor=\"#dddddd\" style=\"border: navy 1px solid; border-color: #000000;\">$_B[2]</td>
              </tr>
              <tr>
               <td colspan=\"3\" bgcolor=\"#fafa00\" style=\"font-size: 1pt; border: navy 1px solid; border-color: #000000;\">&nbsp</td>
              </tr>
              <tr>
               <td bgcolor=\"#dddddd\" style=\"border: navy 1px solid; border-color: #000000;\">$_B[7]</td>
               <td rowspan=\"2\" bgcolor=\"#fafa00\" style=\"border: navy 1px solid; border-color: #000000;\">&nbsp;</td>
               <td bgcolor=\"#dddddd\" style=\"border: navy 1px solid; border-color: #000000;\">$_B[3]</td>
              </tr>
              <tr>
               <td bgcolor=\"#fafa00\" style=\"border: navy 1px solid; border-color: #000000;\">&nbsp;</td>
               <td bgcolor=\"#fafa00\" style=\"border: navy 1px solid; border-color: #000000;\">&nbsp;</td>
              </tr>
              <tr>
               <td bgcolor=\"#fafa00\" style=\"border: navy 1px solid; border-color: #000000;\">&nbsp;</td>
               <td bgcolor=\"#dddddd\" style=\"border: navy 1px solid; border-color: #000000;\" align=\"center\">$_B[6]</td>
               <td bgcolor=\"#fafa00\" style=\"border: navy 1px solid; border-color: #000000;\">&nbsp;</td>
              </tr>
              <tr>
               <td bgcolor=\"#dddddd\" style=\"border: navy 1px solid; border-color: #000000;\">$_B[8]</td>
               <td></td>
               <td bgcolor=\"#dddddd\" style=\"border: navy 1px solid; border-color: #000000;\">$_B[4]</td>
              </tr>
              <tr>
               <td bgcolor=\"#dddddd\" style=\"border: navy 1px solid; border-color: #000000;\">$_B[9]</td>
               <td></td>
               <td bgcolor=\"#dddddd\" style=\"border: navy 1px solid; border-color: #000000;\">$_B[5]</td>
              </tr>
              <tr>
               <td style=\"font-size: 1pt;\">&nbsp;</td>
               <td style=\"font-size: 1pt;\">&nbsp;</td>
               <td style=\"font-size: 1pt;\">&nbsp;</td>
              </tr>
             </table>";
     return $str;
    }

   public static function makeBannerButton($w3,$n)
    {
     // Create banner button for banners submenu
     $link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $field = "banner".$n."ID";
     if($w3->getPreferences($field) != 0) return wm3Util::actionButton("$link&positionID=$n&action=".WM3_cACTION_DEACTIVATE_BANNER,"action_deactivate.png","",""," $n",0,16,16);
    }

   public static function makeBannerExchange($w3,$row,$border = 1,$extern = false,$extra = false)
    {
	 $href = $row->banner_url;
     if($extern) $href = "http://".$w3->getPreferences('site_address')."/".WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&action=".WM3_cACTION_CLICK_BANNER_EXCHANGE."&bannerID=$row->bannerID";
     if($row->banner_source == WM3_cUPLOAD_FROM_REMOTE) $str = "<a href=\"$href\" target=\"_blank\"><img src=\"http://".$w3->getPreferences('site_address')."/".WM3_cPATH_BANNERS."$row->banner_image\" alt=\"".wm3Util::renderContent($w3,$row->banner_alt,WM3_cRENDER_MODE_PLAIN_TEXT)."\" title=\"".wm3Util::renderContent($w3,$row->banner_alt,WM3_cRENDER_MODE_PLAIN_TEXT)."\" width=\"468\" height=\"60\" border=\"$border\"></a>";
	 else                                               $str = "<a href=\"$href\" target=\"_blank\"><img src=\"$row->banner_image\" alt=\"".wm3Util::renderContent($w3,$row->banner_alt,WM3_cRENDER_MODE_PLAIN_TEXT)."\" title=\"".wm3Util::renderContent($w3,$row->banner_alt,WM3_cRENDER_MODE_PLAIN_TEXT)."\" width=\"468\" height=\"60\" border=\"$border\"></a>";
	 if($extra) $str .= "<br>".$w3->getPreferences('banners_exchange_extra_content');
	 return $str;
    }

   public static function makeBannerExchangeCode($w3)
    {
     // Make user banner exchange code to put in other websites
	 $userID       = $w3->getAuthenticateUserID();
	 $site_address = $w3->getPreferences('site_address');
	 require(WM3_cPATH_INCLUDE.'user_banner_exchange_code.inc');
     $form->setTitle($w3->getWord(345));
	 $_F['code']->setValue("<script language=\"JavaScript\" src=\"http://$site_address/".WM3_cCONFIG_BANNER_EXCHANGE_FILE."?stage=".WM3_cSTAGE_BANNER_EXCHANGE."\">\n</script>");
     return $form->render();
    }

   public static function makeBannerExchangeStatistics($w3)
    {
     // Make user banner exchange statistics

     // Banner exchange Statistics
     $_DATA = array();
	 $credits = wm3Banner::getBannerExchangeTotalCredits($w3,$w3->getAuthenticateUserID(),"Unlimited");
     $_DATA[0]->label = $w3->getWord(1317);
     $_DATA[0]->info  = $credits;

     $impressions = wm3Banner::getBannerExchangeTotalImpressions($w3,$w3->getAuthenticateUserID());
     $_DATA[1]->label = $w3->getWord(1318);
     $_DATA[1]->info  = $impressions;

	 $clicks = wm3Banner::getBannerExchangeTotalClicks($w3,$w3->getAuthenticateUserID());
     $_DATA[2]->label = $w3->getWord(1319);
     $_DATA[2]->info  = $clicks;

	 if($impressions > 0) $click_through = $clicks/$impressions*100; else $click_through = 0;
     $_DATA[3]->label = $w3->getWord(-1)."Click through";
     $_DATA[3]->info  = wm3Util::makePercentageBar($w3,$click_through,250,12)." ".round($click_through,4)."%";

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1142));
     $list->setTotalItems(4);
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(40,60));
     return $list->render();
    }

   public static function getBannerExchangeTotalCredits($w3,$userID,$label,$both = false)
    {
	 // Return total banners exchange credits for an user
	 $rs = $w3->getDBObj()->query("SELECT credits,unlimited_credits FROM ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits WHERE userID = '$userID'");
     if($w3->getDBObj()->totalRows($rs) != 1) { if($both) return array('unlimited_credits' => 0, 'credits' => 0); else return 0; }
     $row = $w3->getDBObj()->fetch($rs);
	 if($both) return array('unlimited_credits' => $row->unlimited_credits, 'credits' => $row->credits);
     if($row->unlimited_credits) return $label;
	 return $row->credits;
    }

   public static function getBannerExchangeTotalImpressions($w3,$userID)
    {
	 // Return total banners exchange impressions for an user
	 $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT SUM(impressions) AS total FROM ".WM3_cCONFIG_DB_PREFIX."_banners_exchange WHERE userID = '$userID'"));
	 return $row->total;
    }

   public static function getBannerExchangeTotalClicks($w3,$userID)
    {
	 // Return total banners exchange clicks for an user
	 $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT SUM(clicks) AS total FROM ".WM3_cCONFIG_DB_PREFIX."_banners_exchange WHERE userID = '$userID'"));
	 return $row->total;
    }

   /** Return an array of wm3GUIOption objects for banner type select
	* @param webmatic3 $w3 a webmatic3 instance
	* @return array()
    */
   public static function selectBannerType($w3)
    {
	 return array(new wm3GUIOption($w3->getWord(377),1),
	              new wm3GUIOption($w3->getWord(378),2),
	              new wm3GUIOption($w3->getWord(379),3),
	              new wm3GUIOption($w3->getWord(380),4),
                  new wm3GUIOption($w3->getWord(381),5)); //TODO Costanti(mettere anche dimensioni banner w x h nelle etichette del memorandum qui sopra)
    }

  }

?>
