<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Captcha
  {
   
   function __construct() { }

   /** Render a captcha images directly in the screen
    * @param String $str the captcha string
	* @return void
    */
   public static function renderCaptchaImage($str)
    {
     // This function needs gd extension
     header('Content-type: image/jpeg');

     $length = strlen($str);
     $width  = $length * 36 + 10;
     $height = 36 * 2;
     for($i=0;$i<3;$i++) $font[$i] = imageloadfont(WM3_cPATH_DATA."font".($i+1).".gdf");
     $img = @imagecreatetruecolor($width,$height);
     $bg_color  = imagecolorallocate($img,0xff,0xff,0xff);
     $m = rand(0,1);
     $txt_color = imagecolorallocate($img,rand(190,255)*(!$m),rand(160,255)*$m,rand(160,255)*$m);
     $sha_color = imagecolorallocate($img,50,50,50);
     imagefill($img,0,0,$bg_color);
     for($i = 0; $i < $length; $i++)
      {
	   $x = 36 * $i+rand(5,10);
	   $y = $i+rand(5,36);
	   $f = rand(0,2);
	   imagechar($img,$font[$f],$x+1,$y+1,$str[$i],$sha_color);
       imagechar($img,$font[$f],$x,  $y,  $str[$i],$txt_color);
      }
     $new_width  = (int) ($width  * 1.1);
     $new_height = (int) ($height * 1.2);
     $buf = @imagecreatetruecolor($new_width,$new_height);
     imagecopyresized($buf,$img,0,0,0,0,$new_width,$new_height,$width,$height);
     for($i = 0; $i < 6; $i++)
      {
       imageline($buf,0,rand(0,$new_height),$new_width,rand(0,$new_height),$txt_color);
      }
     imageline($buf,0,rand(0,$new_height),$new_width,rand(0,$new_height),$sha_color);

     imagejpeg($buf,NULL,86);
     imagedestroy($img);
     imagedestroy($buf);
    }

   /** Render the captcha textfield form field
	* @param String $name the textfield form name
	* @return wm3GUITextField
    */
   public static function makeCaptchaField($w3,$name = 'captcha')
    {
	 if(wm3Captcha::canUseCaptcha())
	  {
       $field = new wm3GUITextField($name,'',"Safety code:",40);
        $field->setExtraContentBefore("Please retype the following safety code in the field<br><br><img src=\"".WM3_cCONFIG_CAPTCHA_FILE."?stage=".WM3_cSTAGE_CAPTCHA."\" border=\"1\"<br><br>");
        $field->addValidation(WM3_cVALIDATE_CAPTCHA,"Bad captcha",$w3);
       return $field;
      }
     return null;
	}


   public static function makeCaptcha()
    {
	 // Generate captcha
	 wm3Folder::deleteFolderAllFile(WM3_cPATH_TEMP,'captcha',3600); // Delete old captcha temp file (3600 = 1 hour)
     $captcha     = (string) rand(100000,999999);
	 $captcha_md5 = md5($captcha);
     $file = WM3_cPATH_TEMP."captcha_$captcha_md5";
     $fd   = @fopen($file,"w");
     @fwrite($fd,$captcha);
     @fclose($fd);
	 return wm3Captcha::renderCaptchaImage($captcha);
	}

   public static function testPassedCaptcha($w3,$name)
    {
	 $captcha     = $w3->getVariable($name,'post');
	 $captcha_md5 = md5($captcha);
	 $file = WM3_cPATH_TEMP."captcha_$captcha_md5";
	 $fd   = @fopen($file,"r");
	 if($fd)
	  {
	   if($captcha == @fread($fd,@filesize($file)))
	    {
		 @fclose($fd);
	     @unlink($file);
	     return true;
	    }
	   else
	    {
		 @fclose($fd);
		 return false;
		}
      }
	 return false;
    }

   public static function canUseCaptcha()
    {
	 // Check if captcha can be used
	 return WM3_cCONFIG_USE_CAPTCHA && extension_loaded('gd');
	}

  }

?>
