<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Channel extends wm3Section
  {

   function __construct() { }   

   public static function getSectionParameters()
    {
     // Set the right parameters for channel section
     return array(
                  'section'                       => WM3_cSECTION_CHANNELS,
                  'allowed_section'               => WM3_cSECTION_CHANNELS,
                  'allow_category_description'    => false,
                  'allow_subcategory_description' => false,
                  'category_form'                 => 'admin_channel_category_form.inc',
                  'search_form'                   => 'admin_channel_search_form.inc',
                  'subcategory_form'              => 'admin_channel_subcategory_form.inc',
                  'table_categories'              => '_channels_categories',
                  'table_subcategories'           => '_channels_subcategories',
                  'table_subcategories_count'     => '_channels_subcategories',
                  'table_items_count'             => '_channels_blocks',
                  'action_add_category'           => WM3_cACTION_ADD_CHANNEL_CATEGORY,
                  'action_show_subcategory'       => WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY,
                  'action_add_subcategory'        => WM3_cACTION_ADD_CHANNEL_SUBCATEGORY,
                  'action_disable_category'       => WM3_cACTION_DISABLE_CHANNEL_CATEGORY,
                  'action_enable_category'        => WM3_cACTION_ENABLE_CHANNEL_CATEGORY,
                  'action_edit_category'          => WM3_cACTION_EDIT_CHANNEL_CATEGORY,
                  'action_delete_category'        => WM3_cACTION_DELETE_CHANNEL_CATEGORY,
                  'action_show_items'             => WM3_cACTION_SHOW_CHANNEL_BLOCK,
                  'action_add_item'               => WM3_cACTION_ADD_CHANNEL_BLOCK,
                  'action_disable_subcategory'    => WM3_cACTION_DISABLE_CHANNEL_SUBCATEGORY,
                  'action_enable_subcategory'     => WM3_cACTION_ENABLE_CHANNEL_SUBCATEGORY,
                  'action_edit_subcategory'       => WM3_cACTION_EDIT_CHANNEL_SUBCATEGORY,
                  'action_delete_subcategory'     => WM3_cACTION_DELETE_CHANNEL_SUBCATEGORY,
                  'action_search'                 => WM3_cACTION_SHOW_CHANNEL_BLOCK,
                  'label_category_list_title'     => 953,
                  'label_subcategory_add'         => 1663,
                  'label_subcategories_count'     => 1690,
                  'label_items_count'             => 1692,
                  'label_item_add'                => 954,
                  'label_add_category_title'      => 353,
                  'label_edit_category_title'     => 148,
                  'label_add_subcategory_title'   => 353,
                  'label_edit_subcategory_title'  => 154);
    }

   public static function getChannelBlockFieldsArray()
    {
     return array('blockID','title','subcategoryID','block_type',
				  'pageID','ts','subchannelID',
	              'picture','picture_align','alt','render_mode','description','enabled','languageID','linkID','ts');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_CHANNEL_CATEGORY:
        {
         return wm3Channel::addChannelCategory($w3);
         break;
        }
       case WM3_cACTION_EDIT_CHANNEL_CATEGORY:
        {
         return wm3Channel::editChannelCategory($w3);
         break;
        }
       case WM3_cACTION_DISABLE_CHANNEL_CATEGORY:
        {
         wm3Channel::disableChannelCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Channel::getChannelCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_CHANNEL_CATEGORY:
        {
         wm3Channel::enableChannelCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Channel::getChannelCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_CHANNEL_CATEGORY:
        {
         wm3Channel::deleteChannelCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Channel::getChannelCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_CHANNEL_SUBCATEGORY:
        {
         return wm3Channel::addChannelSubcategory($w3);
         break;
        }
       case WM3_cACTION_DISABLE_CHANNEL_SUBCATEGORY:
        {
         wm3Channel::disableChannelSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Channel::getChannelSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_CHANNEL_SUBCATEGORY:
        {
         wm3Channel::enableChannelSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Channel::getChannelSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_CHANNEL_SUBCATEGORY:
        {
         wm3Channel::deleteChannelSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Channel::getChannelSubcategoryList($w3);
         break;
        }
       case WM3_cACTION_EDIT_CHANNEL_SUBCATEGORY:
        {
         return wm3Channel::editChannelSubcategory($w3);
         break;
        }
       case WM3_cACTION_ADD_CHANNEL_BLOCK:
        {
         return wm3Channel::addChannelBlock($w3);
         break;
        }
       case WM3_cACTION_EDIT_CHANNEL_BLOCK:
        {
         return wm3Channel::editChannelBlock($w3);
         break;
        }
       case WM3_cACTION_DISABLE_CHANNEL_BLOCK:
        {
         wm3Channel::disableChannelBlock($w3,$w3->getVariable('blockID','get'));
         return wm3Channel::getChannelBlockList($w3,$w3->getVariable('blockID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_CHANNEL_BLOCK:
        {
         wm3Channel::enableChannelBlock($w3,$w3->getVariable('blockID','get'));
         return wm3Channel::getChannelBlockList($w3,$w3->getVariable('blockID','get'));
         break;
        }
       case WM3_cACTION_DELETE_CHANNEL_BLOCK:
        {
         wm3Channel::deleteChannelBlock($w3,$w3->getVariable('blockID','get'));
         return wm3Channel::getChannelBlockList($w3);
         break;
        }
    /*   case WM3_cACTION_DUPLICATE_CHANNEL_BLOCK:
        {
         $lastID = wm3Channel::duplicateChannel($w3);
         // $msg= message duplicated... //TODO
         return wm3Channel::getChannelBlockList($w3,$lastID);
         break;
        }*/
       case WM3_cACTION_SHOW_CHANNEL_BLOCK:
        {
         return wm3Channel::getChannelBlockList($w3);
         break;
        }
       case WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY:
        {
         return wm3Channel::getChannelSubcategoryList($w3);
         break;
        }
       default:
        {
         return wm3Channel::getChannelCategoryList($w3);
        }
      }     
    }

   public static function renderChannelBlocks($w3)
    {
     // Render blocks list for a subchannel (home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_CHANNELS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID');
     $subcategoryID = $w3->getVariable('subchannelID');
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.subcategoryID = '$subcategoryID'"; else $query_filter = " AND 1=0";
     $pg = $w3->getVariable('pg');
     $base_link     = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $width_title   = 100;
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.enabled*".WM3_cCONFIG_DB_PREFIX."_channels_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.languageID='".$w3->getHomeLanguage()."'";
     if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_CHANNELS;
     $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.description DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_channels_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_channels_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_channels_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_channels_blocks.subcategoryID
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) {
		                    $title = "&nbsp;"; $content = $w3->getWord(593);
	                        require($w3->getSkinObj()->getChannelBlockNoPicture()); 
	                       }

     // Channel blocks list
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$extra_link."&blockID=$row->blockID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
       if($allowed) {
       	             $allowed_link = $base_allowed_link."&blockID=$row->blockID";
                     $allowed_button = " ".wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_CHANNEL_BLOCK,"action_edit.png",$w3->getWord(178));
                    }
       else          $allowed_button = "";

       // Render blocks
       if($row->block_type == WM3_cCHANNEL_BLOCK_TYPE_PAGE)
	    {
         $title   = wm3Page::makePageLink($row->linkID,$row->title).$allowed_button;
		 $picture = wm3Page::makePageLink($row->linkID,"<img src=\"".WM3_cPATH_IMAGES."$row->picture\" width=\"120\" height=\"90\" alt=\"$row->alt\" title=\"$row->alt\" border=\"0\">");
	    }
       else
	    {
		 $title   = wm3Channel::makeChannelBlockLink(WM3_cCONFIG_HOME_FILE,$row->linkID,$row->title).$allowed_button;
		 $picture = wm3Channel::makeChannelBlockLink(WM3_cCONFIG_HOME_FILE,$row->linkID,"<img src=\"".WM3_cPATH_IMAGES."$row->picture\" width=\"120\" height=\"90\" alt=\"$row->alt\" title=\"$row->alt\" border=\"0\">");
		}

       $content = wm3Util::renderContent($w3,$row->description,$row->render_mode);
       //$content = "&nbsp;".$row->description;
	   if($row->picture_align == WM3_cALIGN_LEFT)  require($w3->getSkinObj()->getChannelBlockLeftPicture());
	   if($row->picture_align == WM3_cNO_IMAGE)    require($w3->getSkinObj()->getChannelBlockNoPicture());
	   if($row->picture_align == WM3_cALIGN_RIGHT) require($w3->getSkinObj()->getChannelBlockRightPicture());
      }

     // Create page navigator
     if($total_items > $max_page_items)//TODO
      {
       $bottom = wm3GUIList::makePagesNavigator($w3,$total_items,$max_page_items,$pg,$base_link."&subchannelID=$subcategoryID");
       require($w3->getSkinObj()->getNewsBottom());
      }
    }

   public static function getChannelCategoryList($w3,$currentID = 0,$admin = true)
    {
   	 return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin);
   	}

   public static function addChannelCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editChannelCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function disableChannelCategory($w3,$categoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableChannelCategory($w3,$categoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteChannelCategory($w3,$categoryID)
    {
     $w3->getSectionObj()->deleteCategory($w3,$categoryID);
    }

   public static function selectChannelCategory($w3,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$all,$admin);
    }

   public static function getChannelCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($w3,$categoryID);
    }

   public static function getChannelSubcategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getSubcategoryList($w3,$currentID,$admin);
    }

   public static function addChannelSubcategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addSubcategory($w3,$error);
    }

   public static function editChannelSubcategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editSubcategory($w3,$error);
    }

   public static function disableChannelSubcategory($w3,$subcategoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories SET enabled = '".WM3_cDISABLED."' WHERE subcategoryID = '$subcategoryID'");
    }

   public static function enableChannelSubcategory($w3,$subcategoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories SET enabled = '".WM3_cENABLED."' WHERE subcategoryID = '$subcategoryID'");
    }
   
   public static function deleteChannelSubcategory($w3,$subcategoryID)
    {
     $w3->getSectionObj()->deleteSubcategory($w3,$subcategoryID);
    }

   public static function getChannelSubcategoryName($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getSubcategoryName($w3,$subcategoryID);
    }

   public static function selectChannelSubcategory($w3,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectSubcategory($w3,$all,$admin);
    }

   public static function getChannelCategoryID($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getCategoryID($w3,$subcategoryID);
    }

   public static function duplicateChannelCategories($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_news
                             WHERE newsID = '".$w3->getVariable('newsID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Channel::getChannelFieldsArray(),$row);
       $_FIELD['title'] = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       //$_FIELD['update_ts'] = $_FIELD['ts'] = time();
       $_FIELD['ts'] = time();
       //$w3->getDBObj()->saveAllTableFields('_news',$_FIELD,array('update_ts'));
       $w3->getDBObj()->saveAllTableFields('_news',$_FIELD);
       return $w3->getDBObj()->getLastInsertID();
      }
    }

   public static function getChannelBlockList($w3,$currentID = 0,$admin = true)
    {
     // Get channel block list

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_CHANNELS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID');
     $subcategoryID = $w3->getVariable('subcategoryID');
     if($subcategoryID && !$categoryID) // When make a search take only subcategoryID (but need also categoryID)
      $categoryID = wm3Channel::getChannelCategoryID($w3,$subcategoryID);
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.subcategoryID = '$subcategoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.description LIKE '%$filter%'";
     	         }
     else        { if(!$subcategoryID) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_CHANNEL_BLOCK;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_CHANNEL_BLOCK."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.enabled*".WM3_cCONFIG_DB_PREFIX."_channels_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.languageID='".$w3->getHomeLanguage()."'";
     	         if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_CHANNELS;
     $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.description DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_channels_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_blocks.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_channels_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_channels_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_channels_blocks.subcategoryID
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'blockID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&blockID=$row->blockID";
       if($allowed) $allowed_link = $base_allowed_link."&blockID=$row->blockID";
       if($subcategoryID) {
						   if($admin) $_DATA[$p]->title = $row->title;
				           else       $_DATA[$p]->title = "<a href=$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_ANNOUNCEMENT.">$row->title</a>";
                          }
       else               {
       	                   // For the search in all categories -> subcategories
						   $_PSEP = $w3->getSkinObj()->getPathSeparator();
                           if($admin) {
							           $_DATA[$p]->title = "$row->title<br>(".$w3->getWord(659)."
                           	                                <a href=\"".$base_link."&categoryID=".$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID)."&action=".WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY."\">".wm3Channel::getChannelCategoryName($w3,$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID))."</a>
                           	                                $_PSEP <a href=\"$base_link$search_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_CHANNEL_BLOCK."\">".wm3Channel::getChannelSubcategoryName($w3,$row->subcategoryID)."</a>)";
									  }
                           else       {
							           $_DATA[$p]->title = "<a href=\"$base_link$page_link&categoryID=".$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID)."&subcategoryID=$row->subcategoryID&announcementID=$row->announcementID&action=".WM3_cACTION_SHOW_SINGLE_ANNOUNCEMENT."\">$row->title</a><br>(".$w3->getWord(659)."
                           	                                <a href=\"$base_link$page_link&categoryID=".$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID)."&action=".WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY."\">".wm3Channel::getChannelCategoryName($w3,$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID))."</a>
                           	                                $_PSEP <a href=\"$base_link$search_link$page_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_CHANNEL_BLOCK."\">".wm3Channel::getChannelSubcategoryName($w3,$row->subcategoryID)."</a>)";
									  }
                          }
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $_DATA[$p]->info = $lang_flag."<br>Linked to $row->block_type (page or channel block";
         // Buttons
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_CHANNEL_BLOCK,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_CHANNEL_BLOCK,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_CHANNEL_BLOCK,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_CHANNEL_BLOCK,"action_delete.png",$w3->getWord(179),$w3->getWord(772));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_CHANNEL_BLOCK,"action_edit.png",$w3->getWord(178));
        }
       if($row->blockID==$currentID && !$found) {  $currentID = $p; $found = true; }
	   $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'');
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_channel_search_form.inc');
     $list->setSearchForm($search_form);
     if($admin) $list->setTitle("<a href=\"$base_link\">".$w3->getWord(953)."</a>");
     else       $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord(953)."</a>");
     if($subcategoryID)
      {
       $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link."&categoryID=$categoryID&action=".WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY."\">".wm3Channel::getChannelCategoryName($w3,$categoryID)."</a>");
       else       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$page_link."&categoryID=$categoryID&action=".WM3_cACTION_SHOW_CHANNEL_SUBCATEGORY."\">".wm3Channel::getChannelCategoryName($w3,$categoryID)."</a>");
       if($admin) $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_CHANNEL_BLOCK."\">".wm3Channel::getChannelSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
       else       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_CHANNEL_BLOCK."\">".wm3Channel::getChannelSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
       if($admin) $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_CHANNEL_BLOCK,"action_add.png","","",$w3->getWord(954),0,16,16));
      }
	 if($found) $list->setCurrentID($currentID);
	 $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_CHANNEL_BLOCK.$id_link.$search_link);
     if($admin) {
                 $list->setCaptionLabels(array($w3->getWord(194),$w3->getWord(1407)));
                 $list->setCaptionWidths(array(50,50));
                 $list->setCaptionColspan(array(1,1,3));
                 $list->setWidths(array(50,50));
			    }
     else       {
		         $list->setRenderCaption(false);
                 $list->setWidths(array(100));
                }
     return $list->render();
    }

   public static function addChannelBlock($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Channel::getChannelBlockFieldsArray());
	 $action = WM3_cACTION_ADD_CHANNEL_BLOCK;
	 require(WM3_cPATH_INCLUDE.'admin_channel_block_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(159));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['subcategoryID']->setValue($w3->getVariable('subcategoryID','get')); // Take subcategoryID from get
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_channels_blocks        WRITE,
		                                   ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories WRITE,
                                           ".WM3_cCONFIG_DB_PREFIX."_channels_categories    WRITE");
       if($form->validate())
        {
         $lastID = wm3Channel::saveChannelBlock($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Channel::getChannelBlockList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }

     // Operation to do before render the form
     if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_PAGE)       $_F['pageID']->setVisible(true);
	 if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL) $_F['subchannelID']->setVisible(true);
     $preview_image = $_FIELD['picture']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_IMAGES); // Set due preview image
     $_F['picture']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),120,90,WM3_cPATH_IMAGES,1,'top','preview_image'));

     return $form->render();
    }

   public static function editChannelBlock($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_CHANNEL_BLOCK;
	 require(WM3_cPATH_INCLUDE.'admin_channel_block_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(157));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                               WHERE blockID = '".$w3->getVariable('blockID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Channel::getChannelBlockFieldsArray(),$row);

       // Default value for fields not in $row object
       switch($_FIELD['block_type'])
        {
         case WM3_cCHANNEL_BLOCK_TYPE_PAGE:       { $_FIELD['pageID']       = $_FIELD['linkID']; $_FIELD['subchannelID'] = 0; break; }
         case WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL: { $_FIELD['subchannelID'] = $_FIELD['linkID']; $_FIELD['pageID']       = 0; break; }
         default: { $_FIELD['pageID'] = $_FIELD['subchannelID'] = 0; }
        }
  
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Channel::getChannelBlockFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_channels_blocks        WRITE,
                                           ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories WRITE,
                                           ".WM3_cCONFIG_DB_PREFIX."_channels_categories    WRITE");
       if($form->validate())
        {
         $lastID = wm3Channel::updateChannelBlock($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Channel::getChannelBlockList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }

     // Operation to do before render the form
     if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_PAGE)       $_F['pageID']->setVisible(true);
	 if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL) $_F['subchannelID']->setVisible(true);
     $preview_image = $_FIELD['picture'];
     $_F['picture']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),120,90,WM3_cPATH_IMAGES,1,'top','preview_image'));

     return $form->render();
    }

   public static function saveChannelBlock($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Channel::getChannelBlockFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_PAGE)       $_FIELD['linkID'] = $_FIELD['pageID'];
	 if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL) $_FIELD['linkID'] = $_FIELD['subchannelID'];
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_channels_blocks',$_FIELD,array('pageID','subchannelID'));
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateChannelBlock($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Channel::getChannelBlockFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_PAGE)       $linkID = $_FIELD['pageID'];
	 if($_FIELD['block_type'] == WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL) $linkID = $_FIELD['subchannelID'];	 
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                       SET   title         = '".$_FIELD['title']."',
					         linkID        = '$linkID',
							 block_type    = '".$_FIELD['block_type']."',
							 picture       = '".$_FIELD['picture']."',
							 alt           = '".$_FIELD['alt']."',
							 description   = '".$_FIELD['description']."',
							 render_mode   = '".$_FIELD['render_mode']."',
							 picture_align = '".$_FIELD['picture_align']."',
                             subcategoryID = '".$_FIELD['subcategoryID']."',
                             enabled       = '".$_FIELD['enabled']."',
                             languageID    = '".$_FIELD['languageID']."'
                       WHERE blockID       = '".$_FIELD['blockID']."'");
     return $_FIELD['blockID'];
    }

   public static function disableChannelBlock($w3,$blockID) { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks SET enabled = '".WM3_cDISABLED."' WHERE blockID = '$blockID'"); }

   public static function enableChannelBlock($w3,$blockID)  { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks SET enabled = '".WM3_cENABLED."' WHERE blockID = '$blockID'"); }
   
   public static function deleteChannelBlock($w3,$blockID)  { $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_channels_blocks WHERE blockID = '$blockID'"); }

   public static function getChannelBlockName($w3,$productID)
    {
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                             WHERE productID = '$productID'");
     $row = $w3->getDBObj()->fetch($rs);
     return $row->name;
    }

   public static function makeChannelBlockLink($file,$blockID,$title,$css = "",$link_only = false)
    {
     // Make link for a channel block
	 if($link_only) return $file."?section=".WM3_cSECTION_CHANNELS."&subchannelID=$blockID";
     return "<a $css href=\"".$file."?section=".WM3_cSECTION_CHANNELS."&subchannelID=$blockID\">$title</a>";
    }

   public static function selectChannelBlockType($w3)
    {
     // Return an array of wm3GUIOption objects for channel block type select
     return wm3Util::selectArray(array("Page",$w3->getWord(804)),
                                 array(WM3_cCHANNEL_BLOCK_TYPE_PAGE,WM3_cCHANNEL_BLOCK_TYPE_SUBCHANNEL));
    }

   public static function renderChannels($w3)
    {
     // Render channels list for panel in home page

     // Prepare variables to create the list

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_channels_categories
               WHERE enabled = '".WM3_cENABLED."' AND languageID = '".$w3->getHomeLanguage()."'
               ORDER BY name";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $_DATA[$p]->nome = $row->name.wm3Channel::renderSubchannels($w3,$row->categoryID);
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setUseColors(false);
     $list->setWidths(array(100));
     return $list->render();
    }


   public static function renderSubchannels($w3,$channelID)
    {
     // Render subchannels list for a channel (panel in home page)

     // Prepare variables to create the list
     $base_link = WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_CHANNELS;
     $id_link = '';

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
               WHERE enabled = '".WM3_cENABLED."' AND categoryID = '$channelID' AND languageID = '".$w3->getHomeLanguage()."'
               ORDER BY ts";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link."&subchannelID=$row->subcategoryID";
       $_DATA[$p]->dummy = "&nbsp;";
       $_DATA[$p]->nome  = "<a href=\"$link\">$row->name ></a>";
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(0,100));
     return $list->render();
    }

  }

?>
