<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Chatroom
  {

   function __construct() { }

   public static function getChatroomFieldsArray()
    {
     return array('chatroomID','name','topic','visibility','enabled','languageID','ts');
    }

   public static function getChatroomSentenceFieldsArray()
    {
     return array('sentenceID','chatroomID','userID','nickname','sentence','enabled','languageID','ts');
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // Chat page content
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_FAQ:
        {
         return wm3Faq::getFaqList($w3,0,false);
         break;
        }
       case WM3_cACTION_SHOW_SINGLE_FAQ:
        {
         return wm3Faq::renderFaq($w3);
         break;
        }
       case WM3_cACTION_ADD_FAQ:
        {
         return "TODO";
         break;
        }
       default:
        {
         return wm3Chatroom::renderChatroom($w3);
        }
      }
    }

   public static function renderChatroom($w3)
    {
     // Render chatroom page (home side)
     $_STYLE['head'] = 1;
	 $_STYLE['body'] = 0;
	 $_STYLE['foot'] = 1;
	 $_FIELD['nickname'] = wm3User::getUserLogin($w3,$w3->getAuthenticateAdminUserID());
	 if($_FIELD['nickname']) $disabled = "disabled"; else $disabled = '';
     require(WM3_cPATH_INCLUDE.'home_chatroom_form.inc');
     return $content;//form->render();
    }

   public static function renderChatroomSentenceList($w3,$currentID = 0,$admin = false)
    {
     // Get chatrooms sentences list (home side)

     // Prepare variables to create the list
     //$allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS); // Used to enable admin buttons in home stage
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();
	 $join_ts    = wm3Session::getChatroomSessionJoinTS($w3);
	 if(!$userID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_chatrooms.visibility = '".WM3_cCHATROOM_VISIBILITY_PUBLIC."'";
	 else         $query_filter = '';
     //$base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     //if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences.ts DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences.*,
	                  ".WM3_cCONFIG_DB_PREFIX."_chatrooms.*
	           FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences,
			        ".WM3_cCONFIG_DB_PREFIX."_chatrooms
			   WHERE ".WM3_cCONFIG_DB_PREFIX."_chatrooms.chatroomID = ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences.chatroomID
			     AND ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences.chatroomID = '$chatroomID'
				 AND ".WM3_cCONFIG_DB_PREFIX."_chatrooms.enabled = '".WM3_cENABLED."'
				 AND ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences.ts >= '$join_ts'
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       //$link = $base_link.$id_link.$extra_link."&chatroomID=$row->chatroomID";
	   $nickname = wm3User::getUserLogin($w3,$row->userID); if(!$nickname) $nickname = $row->nickname;
	   $avatar   = "<img src=\"".wm3User::getAvatar($w3,$row->userID)."\" width=\"36\" height=\"36\"><br>".wm3Util::renderContent($w3,$nickname,WM3_cRENDER_MODE_PLAIN_TEXT);
	   $sentence = wm3Util::renderContent($w3,$row->sentence,WM3_cRENDER_MODE_BB_CODE);
       //if($allowed) $allowed_link = $base_allowed_link."&chatroomID=$row->chatroomID";
       $_DATA[$p]->avatar   = $avatar;
       $_DATA[$p]->sentence = $sentence;
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 $info = $lang_flag.$visibility;
         $_DATA[$p]->info = $info;
         // Buttons
         //$_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_CHATROOM,"action_edit.png",$w3->getWord(178));
         //$_DATA[$p]->b2 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_CHATROOM,"action_delete.png",$w3->getWord(179),$w3->getWord(1452));
        }
       else
        {
         //if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_CHATROOM,"action_edit.png",$w3->getWord(178));
        }
       if($row->chatroomID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
 	 $chatroom_name  = wm3Chatroom::getChatroomName($w3,$chatroomID);
	 $chatroom_topic = wm3Chatroom::getChatroomTopic($w3,$chatroomID);
	 $visibility     = wm3Chatroom::getChatroomVisibility($w3,$chatroomID);
	 if($userID) $nickname = wm3User::getUserLogin($w3,$userID);
	 else        $nickname = $w3->getVariable('nickname','get');
	 $title = "\"".wm3Util::renderContent($w3,$nickname,WM3_cRENDER_MODE_PLAIN_TEXT)."\" ".$w3->getWord(1432).": $chatroom_name<br>Topic: <i>$chatroom_topic</i>";

     $list = new wm3GUIList($w3,$_DATA,$title);
     $list->setTotalItems($total_items);
     $list->setEmptyLabel('');
     if($found) $list->setCurrentID($currentID);
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(0,100));
     return $list->render();
    }

   public static function renderChatroomUserList($w3,$currentID = 0,$admin = false)
    {
     // Get chatrooms current users list (home side)

     // Prepare variables to create the list
     //$allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS); // Used to enable admin buttons in home stage
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();	
  	 if(!$userID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_chatrooms.visibility = '".WM3_cCHATROOM_VISIBILITY_PUBLIC."'";
	 else         $query_filter = '';
     //$base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     //if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms.userID DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms.*,
	                  ".WM3_cCONFIG_DB_PREFIX."_chatrooms.*
	           FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms,
			        ".WM3_cCONFIG_DB_PREFIX."_chatrooms
			   WHERE ".WM3_cCONFIG_DB_PREFIX."_chatrooms.chatroomID = ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms.chatroomID
			     AND ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms.chatroomID = '$chatroomID'
				 AND ".WM3_cCONFIG_DB_PREFIX."_chatrooms.enabled = '".WM3_cENABLED."'
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       //$link = $base_link.$id_link.$extra_link."&chatroomID=$row->chatroomID";
	   if($row->userID) $nickname = wm3User::getUserLogin($w3,$row->userID);
	   else             $nickname = wm3Util::renderContent($w3,$row->nickname,WM3_cRENDER_MODE_PLAIN_TEXT)."<i>(".$row->ip.")</i>";
	   $avatar = "<img src=\"".wm3User::getAvatar($w3,$row->userID)."\" width=\"16\" height=\"16\">";
       //if($allowed) $allowed_link = $base_allowed_link."&chatroomID=$row->chatroomID";
       $_DATA[$p]->avatar   = $avatar;
       $_DATA[$p]->nickname = $nickname;
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 $info = $lang_flag.$visibility;
         $_DATA[$p]->info = $info;
         // Buttons
         //$_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_CHATROOM,"action_edit.png",$w3->getWord(178));
         //$_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_CHATROOM,"action_delete.png",$w3->getWord(179),$w3->getWord(1452));
        }
       else
        {
         //if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_CHATROOM,"action_edit.png",$w3->getWord(178));
        }
       if($row->chatroomID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
 	 $chatroom_name = wm3Chatroom::getChatroomName($w3,$chatroomID);
	 $visibility    = wm3Chatroom::getChatroomVisibility($w3,$chatroomID);
	 $title         = $chatroom_name."<br><i>($total_items users)</i>";

     $list = new wm3GUIList($w3,$_DATA,$title);
     $list->setTotalItems($total_items);
     $list->setEmptyLabel('');
     if($found) $list->setCurrentID($currentID);
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(0,100));
     return $list->render();
    }

   public static function getChatroomList($w3,$currentID = 0,$admin = true)
    {
     // Get Chatrooms list (admin side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE topic LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     if($admin)
      {
	   $search_form_link  = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_CHATROOM;
      }
     else
      {
       if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
       $query_filter .= "enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'";
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_chatrooms.name";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                        $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'chatroomID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&chatroomID=$row->chatroomID";
       if($allowed) $allowed_link = $base_allowed_link."&chatroomID=$row->chatroomID";
	   $name = "<b>".$row->name."</b><br>".$row->topic;
       $_DATA[$p]->name = $name;
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 if($row->visibility==1) $visibility = " (".$w3->getWord(1441)." <img src=\"".WM3_cPATH_DATA."misc_lock_open.png\" width=\"13\" height=\"11\">)";
		 else                    $visibility = " (".$w3->getWord(1442)." <img src=\"".WM3_cPATH_DATA."misc_lock_close.png\" width=\"13\" height=\"11\">)";
		 $info = $lang_flag.$visibility;
         $_DATA[$p]->info = $info;
         // Buttons
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_CHATROOM,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_CHATROOM,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_CHATROOM,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_CHATROOM,"action_delete.png",$w3->getWord(179),$w3->getWord(1452));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_CHATROOM,"action_edit.png",$w3->getWord(178));
        }
       if($row->chatroomID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1444));
     $list->setTotalItems($total_items);
	 if($found) $list->setCurrentID($currentID);
	 $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     if($admin) {
                 require(WM3_cPATH_INCLUDE.'admin_chatroom_search_form.inc');
		         $list->setSearchForm($search_form);
                 $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_CHATROOM.$id_link.$search_link);
                 $list->setCaptionLabels(array($w3->getWord(1439),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(80,20));
                 $list->setCaptionColspan(array(1,1,3));
                 $list->setWidths(array(80,20));
			    }
     else       {
		         $list->setTitle('');
		         $list->setRenderCaption(false);
		         $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_CHATROOM.$id_link.$search_link);
                 $list->setWidths(array(100));
                }
     return $list->render();
    }

   public static function addChatroom($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Chatroom::getChatroomFieldsArray());
	 $action = WM3_cACTION_ADD_CHATROOM;
	 require(WM3_cPATH_INCLUDE.'admin_chatroom_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1435));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3Chatroom::saveChatroom($w3);
         return wm3Chatroom::getChatroomList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function editChatroom($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_CHATROOM;
	 require(WM3_cPATH_INCLUDE.'admin_chatroom_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(1450));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                               WHERE chatroomID = '".$w3->getVariable('chatroomID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Chatroom::getChatroomFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Chatroom::getChatroomFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3Chatroom::updateChatroom($w3);
         return wm3Chatroom::getChatroomList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function saveChatroom($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Chatroom::getChatroomFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_chatrooms',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateChatroom($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Chatroom::getChatroomFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                       SET   name       = '".$_FIELD['name']."',
					         topic      = '".$_FIELD['topic']."',
                             visibility = '".$_FIELD['visibility']."',
						     enabled    = '".$_FIELD['enabled']."',
                             languageID = '".$_FIELD['languageID']."'
                       WHERE chatroomID = '".$_FIELD['chatroomID']."'");
     return $_FIELD['chatroomID'];
    }

   public static function saveChatroomSentence($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Chatroom::getChatroomSentenceFieldsArray(),WM3_cQUOTE_DB);

	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();
     if(!wm3Chatroom::isChatroomAllowed($w3)) return 0;

	 $sentence = wm3Util::quoteDB($w3->getVariable('sentence','get')); // Take sentence from get
	 $nickname = "";//TODO for anonymous;
	 $_FIELD['chatroomID'] = $chatroomID;
	 $_FIELD['userID']     = $userID;
	 if($userID) $_FIELD['nickname'] = ""; else $_FIELD['nickname'] = wm3Util::quoteDB($w3->getVariable('nickname','get'));
	 $_FIELD['sentence']   = $sentence;
	 $_FIELD['enabled']    = WM3_cENABLED;
     $_FIELD['ts']         = time();
     $w3->getDBObj()->saveAllTableFields('_chatrooms_sentences',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function joinChatroom($w3)
    {
	 // Try to join an user in the chatroomID
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();
	 $list = new wm3GUIList($w3,array());
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(100));
	 if(!wm3Chatroom::isChatroomAllowed($w3)) // Private chatroom
	  {
       $list->setTitle($w3->getWord(1438));
       $list->setEmptyLabel($w3->getWord(1443));
       return $list->render();
      }
     if(!wm3Session::chatroomSessionExists($w3)) wm3Session::chatroomSessionCreate($w3);
	 else wm3Session::chatroomSessionUpdate($w3,true); // Update chatroom session (when join a chatroom and the session already exists)
 	 $chatroom_name  = wm3Chatroom::getChatroomName($w3,$chatroomID);
	 $chatroom_topic = wm3Chatroom::getChatroomTopic($w3,$chatroomID);
	 $visibility     = wm3Chatroom::getChatroomVisibility($w3,$chatroomID);
	 if($userID) $nickname = wm3User::getUserLogin($w3,$userID);
	 else        $nickname = $w3->getVariable('nickname','get');
	 $title = "\"".wm3Util::renderContent($w3,$nickname,WM3_cRENDER_MODE_PLAIN_TEXT)."\" ".$w3->getWord(1432).": $chatroom_name<br>Topic: <i>$chatroom_topic</i>";
     $list->setTitle($title);
     $list->setEmptyLabel('');
     return $list->render();
    }

   public static function selectChatroom($w3)
    {
     // Return an array of wm3GUIOption objects for chatrooms select
     $array = array();
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms");
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   if($row->visibility == WM3_cCHATROOM_VISIBILITY_PRIVATE) $visibility = " (".$w3->getWord(1442).")";
	   else                                                     $visibility = " (".$w3->getWord(1441).")";
       array_push($array,new wm3GUIOption($row->name.$visibility,$row->chatroomID));
      }
     return $array;
    }

   public static function selectChatroomVisibility($w3)
    {
     // Return an array of wm3GUIOption objects for chatroom visibility select
	 $_LABELS = array($w3->getWord(1437),$w3->getWord(1438));
	 $_VALUES = array(WM3_cCHATROOM_VISIBILITY_PUBLIC,WM3_cCHATROOM_VISIBILITY_PRIVATE);
     return wm3Util::selectArray($_LABELS,$_VALUES);
    }

   public static function selectChatroomSentenceMode($w3)
    {
     // Return an array of wm3GUIOption objects for chatroom sentence mode select
     $_LABELS = array($w3->getWord(1427),$w3->getWord(1428),$w3->getWord(1429));
	 $_VALUES = array(1,2,3);//TODO costanti
     return wm3Util::selectArray($_LABELS,$_VALUES);
    }

   public static function disableChatroom($w3,$chatroomID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_chatrooms SET enabled = '".WM3_cDISABLED."' WHERE chatroomID = '$chatroomID'");
	}

   public static function enableChatroom($w3,$chatroomID) 
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_chatrooms SET enabled = '".WM3_cENABLED."' WHERE chatroomID = '$chatroomID'");
    }
   
   public static function deleteChatroom($w3,$chatroomID) 
    {
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms WHERE chatroomID = '$chatroomID'");
	}

   public static function getChatroomName($w3,$chatroomID)
    {
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                             WHERE chatroomID = '$chatroomID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return "";
     $row = $w3->getDBObj()->fetch($rs);
     return $row->name;
    }

   public static function getChatroomTopic($w3,$chatroomID)
    {
     $rs = $w3->getDBObj()->query("SELECT topic FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                             WHERE chatroomID = '$chatroomID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return "";
     $row = $w3->getDBObj()->fetch($rs);
     return $row->topic;
    }

   public static function getChatroomVisibility($w3,$chatroomID)
    {
     $rs = $w3->getDBObj()->query("SELECT visibility FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                             WHERE chatroomID = '$chatroomID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return WM3_cCHATROOM_VISIBILITY_PRIVATE;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->visibility;
    }

   public static function isChatroomAllowed($w3)
    {
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();
	 $visibility = wm3Chatroom::getChatroomVisibility($w3,$chatroomID);
  	 if(!$userID && $visibility == WM3_cCHATROOM_VISIBILITY_PRIVATE) return false;
     else return true;
    }

   public static function deleteChatroomExpiredSentences($w3)
    {
	 // Delete expired chatroom sentences
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 if($chatroomID)
	  {
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences
	                     WHERE chatroomID = '$chatroomID'
		                   AND ts < (SELECT MIN(join_ts) FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms WHERE chatroomID = '$chatroomID')");
	  }
     else
	  {
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences
	                     WHERE ts < (SELECT MIN(join_ts) FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms)");
	  }

    }

  }

?>
