<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Guestbook
  {

   function __construct() { }

   public static function getGuestbookMessageFieldsArray()
    {
     return array('messageID','name','email','countryID','message','enabled','languageID','ts','guestbookID');
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // Guestbook page content
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_GUESTBOOK_MESSAGE:
        {
         return wm3Guestbook::addGuestbookMessage($w3);
         break;
        }
       case WM3_cACTION_DELETE_GUESTBOOK_MESSAGE:
        {
		 // Only an administrator can delete from guestbook
		 if($w3->getAuthenticateAdminID()) wm3Guestbook::deleteGuestbookMessage($w3,$w3->getVariable('messageID','get'));
         return wm3Guestbook::getGuestbookMessageList($w3);
         break;
        }
       case WM3_cACTION_DELETE_ALL_GUESTBOOK_MESSAGE:
        {
		 // Only an administrator can reset guestbook
         if($w3->getAuthenticateAdminID()) wm3Guestbook::deleteGuestbookMessage($w3,0,true);
         return wm3Guestbook::getGuestbookMessageList($w3);
         break;
        }
       default:
        {
         return wm3Guestbook::getGuestbookMessageList($w3);
        }
      }     
    }

   public static function getGuestbookMessageList($w3,$currentID = 0,$admin = false)
    {
     // Get guestbook message list (home side)

     // Prepare variables to create the list
     $max_page_items = 12;
	 $allowed = $w3->getAuthenticateAdminID(); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID');
     if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_links.categoryID = '$categoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_links.description LIKE '%$filter%'";
     	         }
     else        $search_link = '';
     $pageID = $w3->getVariable('pageID');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_LINK."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $query_filter .= " WHERE enabled = '".WM3_cENABLED."'";
     $id_link = '';

     // Do the query and take the total items number
     $order_by = " ORDER BY ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'messageID',$rs);
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$search_link.$extra_link.$page_link."&messageID=$row->messageID";
       $country_flag = WM3_cPATH_FLAGS.wm3Statistic::getCountryFlag($w3,$row->countryID);
       $country_name = wm3Statistic::getCountryName($w3,$row->countryID);
       $flag = "<img src=\"$country_flag\" width=\"20\" height=\"13\" align=\"middle\" alt=\"$country_name\" title=\"$country_name\">";
       $name = wm3Util::renderContent($w3,$row->name,WM3_cRENDER_MODE_PLAIN_TEXT);
       $email = "<a href=\"mailto:$row->email\" target=\"_blank\">$row->email</a>";
       $message = wm3Util::renderContent($w3,$row->message,WM3_cRENDER_MODE_PLAIN_TEXT);
       $_DATA[$p]->flag    = $flag;
       $_DATA[$p]->name    = $name;
       $_DATA[$p]->email   = $email;
       $_DATA[$p]->message = $message;
       // Buttons
       if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_GUESTBOOK_MESSAGE,"action_delete.png",$w3->getWord(179),$w3->getWord(699));
       if($row->messageID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
	 $_SEP = $w3->getSkinObj()->getSeparator();
     $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord(1147)."</a> ($total_items)");
	 $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_ADD_GUESTBOOK_MESSAGE,"action_add.png","","",$w3->getWord(1145),0,16,16)." ");
	 if($allowed) $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_DELETE_ALL_GUESTBOOK_MESSAGE,"action_delete.png","",$w3->getWord(1140),$w3->getWord(1144),0,16,16)." ");
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_LINK.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(-1),$w3->getWord(189),$w3->getWord(221),$w3->getWord(1142)));
     $list->setCaptionWidths(array(0,20,20,60));
     $list->setCaptionColspan(array(1,1,1,1,1));
     $list->setWidths(array(0,20,20,60));
     return $list->render();
    }

   public static function addGuestbookMessage($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Guestbook::getGuestbookMessageFieldsArray());
     $_FIELD['pageID'] = $w3->getVariable('pageID'); // Take pageID from both
	 $action = WM3_cACTION_ADD_GUESTBOOK_MESSAGE;
	 require(WM3_cPATH_INCLUDE.'home_guestbook_message_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1145));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3Guestbook::saveGuestbookMessage($w3);
         return wm3Guestbook::getGuestbookMessageList($w3,$lastID);
		}
      }
     return $form->render();
    }

   /*public static function editGuestbook($w3)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_links
                               WHERE linkID = '".$w3->getVariable('linkID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Guestbook::getGuestbookFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Guestbook::getGuestbookFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Guestbook::getGuestbookFieldsArray());
     $pg     = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter');
     switch($error)
      {
       case 1: // No url or bad url
        {
         $_STYLE['url']            = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit link ...."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_...;//TODO
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_link_form.inc");
     return $content;
    }*/

   public static function saveGuestbookMessage($w3)
    {
	 $lastID = 0;
     if(wm3Session::actionAllowed($w3,$w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3,$w3->getVariable('_ID','post'));

       $_FIELD = webmatic3::getPostValueArray(wm3Guestbook::getGuestbookMessageFieldsArray(),WM3_cQUOTE_DB);
       $_FIELD['guestbookID'] = '';
       $_FIELD['enabled']     = WM3_cENABLED;
	   $_FIELD['languageID']  = $w3->getHomeLanguage();
       $_FIELD['ts']          = time();
       $w3->getDBObj()->saveAllTableFields('_guestbooks_messages',$_FIELD);
      }
     return $w3->getDBObj()->getLastInsertID();
    }

/*   public static function updateGuestbook($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Guestbook::getGuestbookFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_links
                       SET url         = '".$_FIELD['url']."',
                           title       = '".$_FIELD['title']."',
                           categoryID  = '".$_FIELD['categoryID']."',
                           description = '".$_FIELD['description']."',
                           enabled    = '".$_FIELD['enabled']."',
                           languageID = '".$_FIELD['languageID']."'
                       WHERE linkID   = '".$_FIELD['linkID']."'");
     return $_FIELD['linkID'];
    }

   public static function disableGuestbookMessage($messageID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages SET enabled = '".WM3_cDISABLED."' WHERE messageID = '$messageID'");
    }

   public static function enableGuestbookMessage($messageID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages SET enabled = '".WM3_cENABLED."' WHERE messageID = '$messageID'");
    }*/
   
   public static function deleteGuestbookMessage($w3,$messageID,$all = false)
    {
     if($all) $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages");
	 else     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages WHERE messageID = '$messageID'");
    }

  }

?>
