<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Link extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for link section
     return array(
                  'section'                   => WM3_cSECTION_LINKS,
                  'allowed_section'           => WM3_cSECTION_LINKS,
                  'category_form'             => 'admin_link_category_form.inc',
                  'search_form'               => 'admin_link_search_form.inc',
                  'table_categories'          => '_links_categories',
                  'table_subcategories'       => '_links',
                  'table_subcategories_count' => '_links',
                  'action_add_category'       => WM3_cACTION_ADD_LINK_CATEGORY,
                  'action_edit_category'      => WM3_cACTION_EDIT_LINK_CATEGORY,
                  'action_show_subcategory'   => WM3_cACTION_SHOW_LINK,
                  'action_add_subcategory'    => WM3_cACTION_ADD_LINK,
                  'action_disable_category'   => WM3_cACTION_DISABLE_LINK_CATEGORY,
                  'action_enable_category'    => WM3_cACTION_ENABLE_LINK_CATEGORY,
                  'action_delete_category'    => WM3_cACTION_DELETE_LINK_CATEGORY,
                  'action_search'             => WM3_cACTION_SHOW_LINK,                  
                  'label_category_list_title' => 1677,
                  'label_subcategory_add'     => 1659,
                  'label_subcategories_count' => 1675);
				  /*,
				  'extra_button_action'       => WM3_cACTION_ADD_LINK,
				  'extra_button_icon'         => 'action_add.png',
				  'extra_button_label'        => 110);// Suggest a link (TODO)*/
    }

   public static function getLinkFieldsArray()
    {
     return array('linkID','url','title','categoryID','render_mode','description','enabled','languageID','ts');
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // Link page content
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_LINK:
        {
         return wm3Link::getLinkList($w3,0,false);
         break;
        }
       case WM3_cACTION_ADD_LINK:
        {
         return "Suggest a link TODO...";
         break;
        }
       default:
        {
         return wm3Link::getLinkCategoryList($w3,0,false);
        }
      }     
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_LINK_CATEGORY:
        {
         return wm3Link::addLinkCategory($w3);
         break;
        }
       case WM3_cACTION_EDIT_LINK_CATEGORY:
        {
         return wm3Link::editLinkCategory($w3);
         break;
        }
       case WM3_cACTION_DISABLE_LINK_CATEGORY:
        {
         wm3Link::disableLinkCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Link::getLinkCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_LINK_CATEGORY:
        {
         wm3Link::enableLinkCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Link::getLinkCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_LINK_CATEGORY:
        {
         wm3Link::deleteLinkCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Link::getLinkCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_LINK:
        {
         return wm3Link::addLink($w3);
         break;
        }
       case WM3_cACTION_EDIT_LINK:
        {
         return wm3Link::editLink($w3);
         break;
        }
       case WM3_cACTION_DISABLE_LINK:
        {
         wm3Link::disableLink($w3,$w3->getVariable('linkID','get'));
         return wm3Link::getLinkList($w3,$w3->getVariable('linkID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_LINK:
        {
         wm3Link::enableLink($w3,$w3->getVariable('linkID','get'));
         return wm3Link::getLinkList($w3,$w3->getVariable('linkID','get'));
         break;
        }
       case WM3_cACTION_DELETE_LINK:
        {
         wm3Link::deleteLink($w3,$w3->getVariable('linkID','get'));
         return wm3Link::getLinkList($w3);
         break;
        }
       case WM3_cACTION_SHOW_LINK:
        {
         return wm3Link::getLinkList($w3);
         break;
        }
       default:
        {
         return wm3Link::getLinkCategoryList($w3);
        }
      }     
    }

   public static function getLinkCategoryList($w3,$currentID = 0,$admin = true) { return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin); }

   public static function addLinkCategory($w3,$error = 0)           { return $w3->getSectionObj()->addCategory($w3,$error); }

   public static function editLinkCategory($w3,$error = 0)          { return $w3->getSectionObj()->editCategory($w3,$error); }

   public static function disableLinkCategory($w3,$categoryID)          { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_links_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'"); }

   public static function enableLinkCategory($w3,$categoryID)           { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_links_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'"); }
   
   public static function deleteLinkCategory($w3,$categoryID)       { $w3->getSectionObj()->deleteCategory($w3,$categoryID); }

   public static function selectLinkCategory($w3,$all = false,$admin = true) { return $w3->getSectionObj()->selectCategory($w3,$all,$admin); }

   public static function getLinkCategoryName($w3,$categoryID)      { return $w3->getSectionObj()->getCategoryName($w3,$categoryID); }

   public static function getLinkList($w3,$currentID = 0,$admin = true)
    {
     // Get link list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_LINKS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID');
     if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_links.categoryID = '$categoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_links.description LIKE '%$filter%'";
     	         }
     else        { if(!$categoryID) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_LINK;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_LINK."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_links.enabled*".WM3_cCONFIG_DB_PREFIX."_links_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_links.languageID='".$w3->getHomeLanguage()."'";
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_LINKS;
     $id_link = "&categoryID=$categoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_links.title DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_links_categories.enabled,".WM3_cCONFIG_DB_PREFIX."_links.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_links_categories,".WM3_cCONFIG_DB_PREFIX."_links
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_links_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_links.categoryID
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'linkID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&linkID=$row->linkID";
       if($allowed) $allowed_link = $base_allowed_link."&linkID=$row->linkID";
       if($row->title) $title = $row->title; else $title = $row->url;
	   $description = wm3Util::renderContent($w3,$row->description,$row->render_mode);
       if($categoryID) {                       
                        if($admin) $_DATA[$p]->title = "<a href=\"$row->url\" target=\"_blank\">$title</a>";
                        else       $_DATA[$p]->title = "<a href=\"$row->url\" target=\"_blank\">$title</a><br>$description";
                       }
       else            {
       	                // For the search in all categories
                        if($admin) $_DATA[$p]->title = "<a href=\"$row->url\" target=\"_blank\">$title</a><br>(".$w3->getWord(659)." <a href=\"$base_link$search_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_LINK."\">".wm3Link::getLinkCategoryName($w3,$row->categoryID)."</a>)";
                        else       $_DATA[$p]->title = "<a href=\"$row->url\" target=\"_blank\">$title</a> (".$w3->getWord(659)." <a href=\"$base_link$search_link$page_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_LINK."\">".wm3Link::getLinkCategoryName($w3,$row->categoryID)."</a>)<br>$description";
                       }
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $_DATA[$p]->info = $lang_flag;
         // Buttons
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_LINK,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_LINK,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_LINK,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_LINK,"action_delete.png",$w3->getWord(179),$w3->getWord(699));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_LINK,"action_edit.png",$w3->getWord(178));
        }
       if($row->linkID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'');
     require(WM3_cPATH_INCLUDE.'admin_link_search_form.inc');
     $list->setSearchForm($search_form);
     $list->setTotalItems($total_items);
     if($admin) $list->setTitle("<a href=\"$base_link\">".$w3->getWord(1677)."</a>");
     else       $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord(1677)."</a>");
     if($categoryID)
      {
       $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_LINK."\">".wm3Link::getLinkCategoryName($w3,$categoryID)." ($total_items)</a>");
       else       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_LINK."\">".wm3Link::getLinkCategoryName($w3,$categoryID)." ($total_items)</a>");
       if($admin) $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_LINK,"action_add.png","","",$w3->getWord(1659),0,16,16));
       //else       $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_ADD_LINK,"action_add.png","","",$w3->getWord(110),0,16,16));//Suggest a link TODO
      }
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     if($admin) {
                 $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_LINK.$id_link.$search_link);
                 $list->setCaptionLabels(array($w3->getWord(194),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(70,30));
                 $list->setCaptionColspan(array(1,1,3));
                 $list->setWidths(array(70,30));
			    }
     else       {
                 $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_LINK.$id_link.$search_link);
		         $list->setRenderCaption(false);
                 $list->setWidths(array(100));
                }
     return $list->render();
    }

   public static function addLink($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Link::getLinkFieldsArray());
	 $action = WM3_cACTION_ADD_LINK;
	 require(WM3_cPATH_INCLUDE.'admin_link_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(351));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['categoryID']->setValue($w3->getVariable('categoryID','get')); // Take categoryID from get
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_links            WRITE,
                                     ".WM3_cCONFIG_DB_PREFIX."_links_categories WRITE");
       if($form->validate())
        {
         $lastID = wm3Link::saveLink($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Link::getLinkList($w3,$lastID);
		}
	   $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function editLink($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_LINK;
	 require(WM3_cPATH_INCLUDE.'admin_link_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit link");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_links
                               WHERE linkID = '".$w3->getVariable('linkID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Link::getLinkFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Link::getLinkFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_links            WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_links_categories WRITE");
       if($form->validate())
        {
         $lastID = wm3Link::updateLink($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Link::getLinkList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function saveLink($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Link::getLinkFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_links',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateLink($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Link::getLinkFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_links
                       SET url         = '".$_FIELD['url']."',
                           title       = '".$_FIELD['title']."',
                           categoryID  = '".$_FIELD['categoryID']."',
                           description = '".$_FIELD['description']."',
						   render_mode = '".$_FIELD['render_mode']."',
                           enabled     = '".$_FIELD['enabled']."',
                           languageID  = '".$_FIELD['languageID']."'
                       WHERE linkID    = '".$_FIELD['linkID']."'");
     return $_FIELD['linkID'];
    }

   public static function duplicateLink($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_links
                             WHERE linkID = '".$w3->getVariable('linkID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Link::getLinkFieldsArray(),$row);
       $_FIELD['title'] = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['ts'] = time();
       $w3->getDBObj()->saveAllTableFields('_links',$_FIELD);
       return $w3->getDBObj()->getLastInsertID();
      }
    }

   public static function disableLink($w3,$linkID) { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_links SET enabled = '".WM3_cDISABLED."' WHERE linkID = '$linkID'"); }

   public static function enableLink($w3,$linkID)  { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_links SET enabled = '".WM3_cENABLED."' WHERE linkID = '$linkID'"); }
   
   public static function deleteLink($w3,$linkID)  { $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_links WHERE linkID = '$linkID'"); }

  }

?>
