<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Newsletter
  {

   function __construct() { }

   public static function getNewsletterFieldsArray()
    {
     return array('newsletterID',
	              'newsletter_target','user_gender','groupID','ignore_disabled','newsletter_action',
				  'subject','newsletter_format','newsletter','newsletter_use_foot','languageID','save_newsletter','emails_sended','newsletter_target_users','ts','newsletter_foot','enabled');
    }

   public static function getNewsletterItemFieldsArray()
    {
     return array('newsletter_itemID','email','enabled','languageID','ts');
    }

   public static function executeHomeAction($w3)
    {
     switch($w3->getAction())
      {
       default:
        {
         return wm3Newsletter::renderContact($w3);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_NEWSLETTER_ITEM:
        {
         wm3Newsletter::disableNewsletterItem($w3,$w3->getVariable('newsletter_itemID','get'));
         return wm3Newsletter::getNewsletterItemList($w3,$w3->getVariable('newsletter_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_NEWSLETTER_ITEM:
        {
         wm3Newsletter::enableNewsletterItem($w3,$w3->getVariable('newsletter_itemID','get'));
         return wm3Newsletter::getNewsletterItemList($w3,$w3->getVariable('newsletter_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_NEWSLETTER_ITEM:
        {
         wm3Newsletter::deleteNewsletterItem($w3,$w3->getVariable('newsletter_itemID','get'));
         return wm3Newsletter::getNewsletterItemList($w3);
         break;
        }
       case WM3_cACTION_ADD_NEWSLETTER_ITEM:
        {
         return wm3Newsletter::addNewsletterItem($w3);
         break;
        }
       case WM3_cACTION_EDIT_NEWSLETTER_ITEM:
        {
         return wm3Newsletter::editNewsletterItem($w3);
         break;
        }
       case WM3_cACTION_DELETE_NEWSLETTER:
        {
         wm3Newsletter::deleteNewsletter($w3,$w3->getVariable('newsletterID','get'));
         return wm3Newsletter::getNewsletterList($w3);
         break;
        }
       case WM3_cACTION_WRITE_NEWSLETTER:
        {
         return wm3Newsletter::writeNewsletter($w3);
         break;
        }
       case WM3_cACTION_RESEND_NEWSLETTER:
        {
         return wm3Newsletter::resendNewsletter($w3);
         break;
        }
       case WM3_cACTION_SHOW_NEWSLETTER:
        {
         return wm3Newsletter::getNewsletterList($w3);
         break;
        }
       default:
        {
         return wm3Newsletter::getNewsletterItemList($w3);
        }
      }
    }

   public static function getNewsletterItemList($w3,$currentID = 0)
    {
     // Get newsletter emails list
     $max_page_items = 12;
     $filter = $w3->getVariable('filter'); // Search field
	 $pg = $w3->getVariable('pg');
     if($filter) {
		          $search_link = "&filter=$filter";
     	          $query_filter = "WHERE email LIKE '%$filter%'";
     	         }
     else        { $search_link = $query_filter = ""; }
	 $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY email";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters_items $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'newsletter_itemID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&newsletter_itemID=$row->newsletter_itemID";
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" width=\"19\" height=\"13\" align=\"middle\">";
       $_DATA[$p]->email = "<a href=\"mailto:$row->email\">$row->email</a>";
       $_DATA[$p]->info  = $lang_flag;
       // Buttons
       if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_NEWSLETTER_ITEM,"action_disable.png",$w3->getWord(180));
       else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_NEWSLETTER_ITEM,"action_enable.png",$w3->getWord(181));
       $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_NEWSLETTER_ITEM,"action_edit.png",$w3->getWord(178));
       $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_NEWSLETTER_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
       if($row->newsletter_itemID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(89));
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_newsletter_search_form.inc');
     $list->setSearchForm($search_form);
     if($found) $list->setCurrentID($currentID);
	 $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(221),$w3->getWord(1671)));
     $list->setCaptionWidths(array(60,40));
     $list->setCaptionColspan(array(1,1,3));
     $list->setWidths(array(60,40));

     return $list->render();
    }

   public static function checkNewsletterItemError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterItemFieldsArray());
	 if(!wm3Util::isEmail($_FIELD['email']))              return 1;
	 if(wm3Newsletter::emailExists($w3,$_FIELD['email'])) return 2;
     return 0;
    }

   public static function checkSendToFriendError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(array('newsletter_itemID','friend_email','your_email','newsletter'));
	 if(!wm3Util::isEmail($_FIELD['friend_email'])) return 1;
	 if(!wm3Util::isEmail($_FIELD['your_email']))   return 2;
     return 0;
    }

   public static function addNewsletterItem($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterItemFieldsArray());
	 $action = WM3_cACTION_ADD_NEWSLETTER_ITEM;
	 require(WM3_cPATH_INCLUDE.'admin_newsletter_item_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(351));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE");
       if($form->validate())
        {
         $lastID = wm3Newsletter::saveNewsletterItem($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Newsletter::getNewsletterItemList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function editNewsletterItem($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_NEWSLETTER_ITEM;
	 require(WM3_cPATH_INCLUDE.'admin_newsletter_item_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit email");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                               WHERE newsletter_itemID = '".$w3->getVariable('newsletter_itemID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Newsletter::getNewsletterItemFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterItemFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE");
       if($form->validate())
        {
         $lastID = wm3Newsletter::updateNewsletterItem($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Newsletter::getNewsletterItemList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function saveNewsletterItem($w3,$_FIELD = array())
    {
     if(count($_FIELD) == 0) $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterItemFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_newsletters_items',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateNewsletterItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterItemFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                       SET email               = '".$_FIELD['email']."',
                           enabled             = '".$_FIELD['enabled']."',
                           languageID          = '".$_FIELD['languageID']."'
                       WHERE newsletter_itemID = '".$_FIELD['newsletter_itemID']."'");
     return $_FIELD['newsletter_itemID'];
    }

   public static function synchronizeNewsletterItem($w3)
    {
	 // Take email from varius tables and store it in newsletters (if not already stored)	 
	 $str = ""; $i = 0;
	 $_FIELD['newsletter_itemID'] = '';
	 $_FIELD['enabled']           = WM3_cENABLED;

	 // From users
     $rs = $w3->getDBObj()->query("SELECT email,languageID FROM ".WM3_cCONFIG_DB_PREFIX."_users");
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $_FIELD['email']      = $row->email;
	   $_FIELD['languageID'] = $row->languageID;
	   $_FIELD['ts']         = time();
       if(!wm3Newsletter::emailExists($w3,$row->email))
	    {
		 $w3->getDBObj()->saveAllTableFields('_newsletters_items',$_FIELD);
		 $i++;
		}
      }
	 $str .= "<i>$i email synchronized from users</i>"; $i = 0;

	 // From guestbook
     $rs = $w3->getDBObj()->query("SELECT email,languageID FROM ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages");
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $_FIELD['email']      = $row->email;
	   $_FIELD['languageID'] = $row->languageID;
	   $_FIELD['ts']         = time();
       if(!wm3Newsletter::emailExists($w3,$row->email))
	    {
		 $w3->getDBObj()->saveAllTableFields('_newsletters_items',$_FIELD);
		 $i++;
		}
      }
	 $str .= "<br><i>$i email synchronized from guestbook</i>";
     return $str;
    }

   public static function selectNewsletterTarget($w3)
    {
     // Return an array of wm3GUIOption objects for newsletter target select
     return wm3Util::selectArray(array($w3->getWord(320),$w3->getWord(321)),
                                 array(WM3_cNEWSLETTER_TARGET_MEMBERS,WM3_cNEWSLETTER_TARGET_USERS));
    }

   public static function selectNewsletterGender($w3)
    {
     // Return an array of wm3GUIOption objects for newsletter gender select
     return wm3Util::selectArray(array($w3->getWord(528),$w3->getWord(529),$w3->getWord(530),$w3->getWord(823)),
                                 array(WM3_cUSER_ALL,WM3_cUSER_GENDER_MALE,WM3_cUSER_GENDER_FEMALE,WM3_cUSER_SPECIAL));
    }

   public static function selectNewsletterAction($w3)
    {
     // Return an array of wm3GUIOption objects for newsletter action select
     return wm3Util::selectArray(array($w3->getWord(531),$w3->getWord(532)),
                                 array(WM3_cNEWSLETTER_ACTION_SEND,WM3_cNEWSLETTER_ACTION_SIMULATE));
    }

   public static function selectNewsletterType($w3)
    {
     // Return an array of wm3GUIOption objects for newsletter type select
     return wm3Util::selectArray(array($w3->getWord(550),$w3->getWord(549)),
                                 array(WM3_cNEWSLETTER_FORMAT_TEXT,WM3_cNEWSLETTER_FORMAT_HTML));
    }

   public static function duplicateNewsletterItem($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages
                             WHERE messageID = '".$w3->getVariable('messageID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Newsletter::getNewsletterItemFieldsArray(),$row);
       $_FIELD['message'] = $w3->getWord(1417).$_FIELD['message'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['update_ts'] = $_FIELD['ts'] = time();
       $w3->getDBObj()->saveAllTableFields('_messages',$_FIELD,array('update_ts'));
       return $w3->getDBObj()->getLastInsertID();
      }
    }

   public static function disableNewsletterItem($w3,$newsletter_itemID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items SET enabled = '".WM3_cDISABLED."' WHERE newsletter_itemID = '$newsletter_itemID'");
    }

   public static function enableNewsletterItem($w3,$newsletter_itemID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items SET enabled = '".WM3_cENABLED."' WHERE newsletter_itemID = '$newsletter_itemID'");
    }
   
   public static function deleteNewsletterItem($w3,$newsletter_itemID)
    {
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WHERE newsletter_itemID = '$newsletter_itemID'");
    }

   public static function enableNewsletterItemEmail($w3,$email)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items SET enabled = '".WM3_cENABLED."' WHERE email = '$email'");
    }

   public static function getNewsletterList($w3,$currentID = 0)
    {
     // Get sended newsletter list
     $max_page_items = 12;
     $filter = $w3->getVariable('filter'); // Search field
	 $pg = $w3->getVariable('pg');
     if($filter) {
		          $search_link = "&filter=$filter";
     	          $query_filter = "WHERE newsletter LIKE '%$filter%'";
     	         }
     else        { $search_link = $query_filter = ''; }
	 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_NEWSLETTER;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'newsletterID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&newsletterID=$row->newsletterID";
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" width=\"19\" height=\"13\" align=\"middle\">";
	   $subject = "$row->subject<br>".wm3Util::renderDate($w3,$row->ts,$w3->getAdminLanguage());
	   if($row->newsletter_format == WM3_cNEWSLETTER_FORMAT_HTML) $format = $w3->getWord(549); else $format = $w3->getWord(550);
	   $info    = "$lang_flag ($row->emails_sended emails sended)<br>".$w3->getWord(324)." $format";
       $_DATA[$p]->subject = $subject;
       $_DATA[$p]->info    = $info;
       // Buttons
       $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_RESEND_NEWSLETTER,"action_reset.png",$w3->getWord(1132));
       $_DATA[$p]->b2 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_NEWSLETTER,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
       if($row->newsletterID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1134));
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_newsletter_search_form.inc');
     $list->setSearchForm($search_form);
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_NEWSLETTER.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(228),$w3->getWord(1671)));
     $list->setCaptionWidths(array(60,40));
     $list->setCaptionColspan(array(1,1,2));
     $list->setWidths(array(60,40));

     return $list->render();
    }

   public static function writeNewsletter($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterFieldsArray());
	 $foot_text = wm3Newsletter::makeNewsletterFoot($w3,WM3_cNEWSLETTER_FORMAT_TEXT,true);
	 $foot_html = wm3Newsletter::makeNewsletterFoot($w3,WM3_cNEWSLETTER_FORMAT_HTML,true);
	 $action = WM3_cACTION_WRITE_NEWSLETTER;
	 require(WM3_cPATH_INCLUDE.'admin_newsletter_form.inc');
     $form->setSubmitLabel($w3->getWord(294));
     $form->setTitle($w3->getWord(370));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['newsletter_use_foot']->setValue(WM3_cENABLED);
       $_F['newsletter_foot']->setVisible(true);
       $_F['newsletter_format']->setValue(WM3_cNEWSLETTER_FORMAT_TEXT);
      }
     else if($form->validate()) return wm3Newsletter::sendNewsletter($w3);

     // Operation to do before render the form
     if($_FIELD['newsletter_target']   == WM3_cNEWSLETTER_TARGET_USERS) { $_F['user_gender']->setVisible(true); $_F['groupID']->setVisible(true); }
	 if($_FIELD['newsletter_use_foot'] == WM3_cENABLED)                 $_F['newsletter_foot']->setVisible(true);
	 $_F['newsletter_foot']->setValue(wm3Newsletter::makeNewsletterFoot($w3,$_F['newsletter_format']->getValue()));

     return $form->render();
    }

   public static function sendNewsletter($w3)
    {
     // Send the newsletter

	 // Prepare variables to create the emails list and send the newsletter
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterFieldsArray(),WM3_cQUOTE_DB);
	 if($_FIELD['newsletter_target'] == WM3_cNEWSLETTER_TARGET_MEMBERS) // Newsletter members
	  {
	   $buttons = 3;
	   $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();

       // Newsletter synchronization
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items   WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_users               WRITE,
									 ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages WRITE");
	   $synchronize_message = "<br><br>".wm3Newsletter::synchronizeNewsletterItem($w3);
       $w3->getDBObj()->query("UNLOCK TABLES");
	  }
	 if($_FIELD['newsletter_target'] == WM3_cNEWSLETTER_TARGET_USERS) // Users
	  {
	   $buttons = 1;
	   $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_USERS;
	   $synchronize_message = "";
	  }
	 if($_FIELD['ignore_disabled']) $query_filter = "WHERE 1=1"; else $query_filter = "WHERE enabled = '".WM3_cENABLED."'";
     $id_link = '';

     // Do the query and take the total items number
	 if($_FIELD['newsletter_target'] == WM3_cNEWSLETTER_TARGET_MEMBERS) // Newsletter members
	  {
       $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters_items $query_filter";
	  }
     if($_FIELD['newsletter_target'] == WM3_cNEWSLETTER_TARGET_USERS) // Users
	  {
	   if($_FIELD['user_gender'] == WM3_cUSER_GENDER_MALE)   $query_filter .= " AND gender = 'M'";
	   if($_FIELD['user_gender'] == WM3_cUSER_GENDER_FEMALE) $query_filter .= " AND gender = 'F'";
	   if($_FIELD['user_gender'] == WM3_cUSER_SPECIAL)       $query_filter .= " AND special = '".WM3_cENABLED."'";
	   if($_FIELD['groupID']) $query_filter .= " AND groupID = '".$_FIELD['groupID']."'";
       $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users $query_filter";
	  }
	 $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Save the newsletter
	 if($_FIELD['save_newsletter']) wm3Newsletter::saveNewsletter($w3,$total_items);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {	   
	   if($_FIELD['newsletter_action'] == WM3_cNEWSLETTER_ACTION_SEND) // Really send the newsletter
	     {
		  //$email_body = stripslashes($_FIELD['newsletter']);
		  $email_body = $_FIELD['newsletter'];
		  if($_FIELD['newsletter_use_foot']) $email_body .= $_FIELD['newsletter_foot'];
		  $sender = $w3->getPreferences('service_email');
          if($_FIELD['newsletter_format'] == WM3_cNEWSLETTER_FORMAT_TEXT) $sended = @mail($row->email,$_FIELD['subject'],$email_body,"From: $sender\nX-Mailer: PHP/".phpversion());
          if($_FIELD['newsletter_format'] == WM3_cNEWSLETTER_FORMAT_HTML) $sended = @mail($row->email,$_FIELD['subject'],$email_body,"From: $sender\nX-Mailer: PHP/".phpversion()."\nMIME-Version: 1.0\nContent-Type: text/html; charset=\"iso-8859-1\"\nContent-Transfer-Encoding: 7bit\n\n");
		 }
	   else $sended = true;

       if($sended) $sended = "<b>Sended OK!</b>";
	   else        $sended = "<b>Not sended, Error!</b>";
       if($_FIELD['newsletter_target'] == WM3_cNEWSLETTER_TARGET_MEMBERS) // Newsletter members
	    {
		 $buttons = 3;
	     $link = $base_link.$id_link."&newsletter_itemID=$row->newsletter_itemID";
		 $_DATA[$p]->email = "$row->email $sended";
	    }
	   if($_FIELD['newsletter_target'] == WM3_cNEWSLETTER_TARGET_USERS) // Users
	    {
		 $buttons = 1;
		 $link = $base_link.$id_link."&userID=$row->userID";
         //$lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" width=\"19\" height=\"13\" align=\"middle\">";
		 $_DATA[$p]->email = "$row->email, $row->name $row->surname ($row->login) $sended";
	    }

       // Buttons
	   if($_FIELD['newsletter_target'] == WM3_cNEWSLETTER_TARGET_MEMBERS) // Newsletter members
	    {
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_NEWSLETTER_ITEM,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_NEWSLETTER_ITEM,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_NEWSLETTER_ITEM,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_NEWSLETTER_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
		}
	   if($_FIELD['newsletter_target'] == WM3_cNEWSLETTER_TARGET_USERS) // Users
	    {
         //if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_USER,"action_disable.png",$w3->getWord(180)));
         //else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_USER,"action_enable.png",$w3->getWord(181)));
         $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_USER,"action_edit.png",$w3->getWord(178));
		}
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(371).$synchronize_message);
     $list->setTotalItems($total_items);
     $list->setCaptionLabels(array($w3->getWord(221)));
     $list->setCaptionWidths(array(100));
     $list->setCaptionColspan(array(1,$buttons));
     $list->setWidths(array(100));
     $list->setRenderPagesNavigator(false);
     $list->setBottomContent($w3->getWord(615)." $total_items ".$w3->getWord(616));
     return $list->render();
    }

   public static function resendNewsletter($w3)
    {
     // Initialize form
	 $foot_text = wm3Newsletter::makeNewsletterFoot($w3,WM3_cNEWSLETTER_FORMAT_TEXT,true);
	 $foot_html = wm3Newsletter::makeNewsletterFoot($w3,WM3_cNEWSLETTER_FORMAT_HTML,true);
	 $action = WM3_cACTION_WRITE_NEWSLETTER;//WM3_cACTION_SEND_NEWSLETTER
	 require(WM3_cPATH_INCLUDE.'admin_newsletter_form.inc');
     $form->setSubmitLabel($w3->getWord(294));
     $form->setTitle($w3->getWord(370));

     // Render form
     // Take variables value from db
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters
                             WHERE newsletterID = '".$w3->getVariable('newsletterID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
	 if(!$row) return wm3GUIList::makeNotFoundItem($w3);
     $_FIELD = webmatic3::getRowValueArray(wm3Newsletter::getNewsletterFieldsArray(),$row);

     // Default value for fields not in $row object
     $_F['save_newsletter']->setValue(WM3_cDISABLED);
     $_F['newsletter_action']->setValue(WM3_cNEWSLETTER_ACTION_SEND);

     $form->setFieldsValues($_FIELD);

     // Operation to do before render the form
     if($_FIELD['newsletter_target']   == WM3_cNEWSLETTER_TARGET_USERS) { $_F['user_gender']->setVisible(true); $_F['groupID']->setVisible(true); }
	 if($_FIELD['newsletter_use_foot'] == WM3_cENABLED)                 $_F['newsletter_foot']->setVisible(true);
	 $_F['newsletter_foot']->setValue(wm3Newsletter::makeNewsletterFoot($w3,$_F['newsletter_format']->getValue()));

     return $form->render();
    }

   public static function saveNewsletter($w3,$emails_sended)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['emails_sended'] = $emails_sended;
	 $_FIELD['enabled']       = WM3_cENABLED;
     $_FIELD['ts']            = time();
     $w3->getDBObj()->saveAllTableFields('_newsletters',$_FIELD,array('newsletter_action','save_newsletter','newsletter_target_users','newsletter_foot'));
     //return $w3->getDBObj()->getLastInsertID();
    }

   public static function deleteNewsletter($w3,$newsletterID)
    {
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters WHERE newsletterID = '$newsletterID'");
    }

   public function makeNewsletterFoot($w3,$type,$quote = false)
    {
	 if($type == WM3_cNEWSLETTER_FORMAT_TEXT)
	  {
	   $str = "\n\n---------------------\n\n"; // Plain text
	   $link = "SITO?...TODO";
      }
	 else
	  {
	   $str = "<br><br><hr><br>\n\n"; // HTML
	   $link = "<a href=\"TODO\">SITO?...TODO</a>";
	  }
     $str .= $w3->getWord(186).$link;
	 if($quote)
	  {
	   $str = str_replace("\n" ,"\\n", $str);
	   $str = str_replace("'" ,"\'",   $str);
	   $str = str_replace("\"" ,"\&quot;",$str);
      }
	 return $str;
    }

   public static function renderNewsletter($w3)
    {
     // Render newsletter panel in home page
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_HOME;

     // Create newsletter panel
     $link = $base_link;
     $_DATA = array(); $_COLSPAN = array();
	 if($w3->getPreferences('show_total_newsletter'))
	  {
       $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWSLETTER);
       if($allowed) {
	                 $total          = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items');
	                 $total_disabled = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items',"WHERE enabled='".WM3_cDISABLED."'");
                     $total_enabled  = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items',"WHERE enabled='".WM3_cENABLED."'");
					 $label = $w3->getWord(320)." $total<br>($total_disabled disabled, $total_enabled enabled)";
			        }
       else         {
	                 $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items',"WHERE enabled='".WM3_cENABLED."'");
					 $label = $w3->getWord(320)." $total";
		            }
       $_DATA[0]->label = '<br>'.$label;
       $_COLSPAN[0] = array(2);
      }

     // Render form
     $textfield = new wm3GUITextField('email','',$w3->getWord(221),16);
     $form = new wm3GUIForm($w3,$link.'&action='.WM3_cACTION_NEWSLETTER_JOIN,'','wm3_form',array($textfield));
     $form->setRenderResetButton(false);
     $form->setUseWasSubmit(false);
     $form->setSubmitLabel($w3->getWord(294));

     // Render List
     $str = '';
     if(count($_DATA) > 0)
      {
       $list = new wm3GUIList($w3,$_DATA,'',$_COLSPAN);
       $list->setRenderCaption(false);
       $list->setRenderPagesNavigator(false);
       $list->setWidths(array(100));
       $str = $list->render();
      }
     return $form->render().$str;
    }

   public static function joinNewsletter($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Newsletter::getNewsletterItemFieldsArray());
     $error = wm3Newsletter::checkNewsletterItemError($w3);
     switch($error)
      {
       case 1: // Invalid email
        {
		 $w3->getPageObj()->setSubTitle($w3->getWord(1151));
         return $w3->getWord(443)." <b>\"".wm3Util::renderContent($w3,$_FIELD['email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"</b> ".$w3->getWord(444);
         break;
        }
       case 2: // Email already exists
        {
		 $w3->getPageObj()->setSubTitle("Email already exists");
		 wm3Newsletter::enableNewsletterItemEmail($w3,$_FIELD['email']); // Eneble the newsletter item if exists
		 return "<b>\"".$_FIELD['email']."\"</b> ".$w3->getWord(64);
         break;
        }
       default: // No error
        {
		 $_FIELD['enabled']    = WM3_cENABLED;
		 $_FIELD['languageID'] = $w3->getHomeLanguage();
		 $_FIELD['ts']         = time();
         wm3Newsletter::saveNewsletterItem($w3,$_FIELD);
		 $w3->getPageObj()->setSubTitle("Email added");
         return "Email <b>\"".$_FIELD['email']."\"</b> was added to our newsletter";
     	}
      }
    }

   public static function renderSendToFriend($w3)
    {
     // Render send to friend panel in home page
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_HOME;

     // Create send to friend panel     
     $link = $base_link;
     $_DATA = array(); $_COLSPAN = array();    
	 if($w3->getPreferences('show_total_signalations'))
	  {
       $label = '<br>'.wm3Preferences::loadTotalSignalations($w3).' '.$w3->getWord(1484);
       $_DATA[0]->label = $label;
       $_COLSPAN[0] = array(2);
      }

     // Render form
     $friend_email = new wm3GUITextField('friend_email','',$w3->getWord(1522),16);
     $your_email   = new wm3GUITextField('your_email','',$w3->getWord(1520),16);
	 $newsletter   = new wm3GUICheckBox ('newsletter','','Join newsletter');
	 $_ID          = new wm3GUIHiddenField('_ID',time());
     $form = new wm3GUIForm($w3,$link.'&action='.WM3_cACTION_SEND_TO_FRIEND,'','wm3_form',array($friend_email,$your_email,$newsletter,$_ID));
     $form->setRenderResetButton(false);
     $form->setUseWasSubmit(false);
     $form->setSubmitLabel($w3->getWord(595));

     // Render List
     $str = '';
     if(count($_DATA) > 0)
      {
       $list = new wm3GUIList($w3,$_DATA,'',$_COLSPAN);
       $list->setRenderCaption(false);
       $list->setRenderPagesNavigator(false);
       $list->setWidths(array(100));
       $str = $list->render();
      }
     return $form->render().$str;
    }

   public static function addToNewsletterSendToFriend($w3)
    {
     if(wm3Session::actionAllowed($w3,$w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3,$w3->getVariable('_ID','post'));

       $_FIELD = webmatic3::getPostValueArray(array('newsletter_itemID','friend_email','your_email','newsletter'),WM3_cQUOTE_DB);

       // Subscribe email also to newsletter
       if($_FIELD['newsletter']) $enabled = WM3_cENABLED; else $enabled = WM3_cDISABLED;
	   wm3Newsletter::addToNewsletter($w3,$_FIELD['friend_email'],$enabled);
	   wm3Newsletter::addToNewsletter($w3,$_FIELD['your_email'],$enabled);
       return true;
      }
	 return false; // Protected action error
    }

   public static function sendSendToFriend($w3,$allowed,$use_post_subject = false,$use_post_message = false)
    {
	 $w3->getPageObj()->setRenderHeadFoot(false);
     if($allowed)
      {
       $_FIELD = webmatic3::getPostValueArray(array('newsletter_itemID','friend_email','your_email','subject','message','message_head','newsletter'),WM3_cQUOTE_DB);
	   // Send the email to a friend
	   $friend_email = $_FIELD['friend_email'];
	   $your_email   = $_FIELD['your_email'];
       $sender     = $w3->getPreferences('service_email');
       if($use_post_subject) $subject = $_FIELD['subject'];
	   else                  $subject = $w3->getPreferencesContents('signalation_email_subject');
	   $subject .= " (from $your_email)";
       if($use_post_message) $email_body = $_FIELD['message'];
	   else                  $email_body = $w3->getPreferencesContents('signalation_email_text');
	   $email_body = $_FIELD['message_head'].$email_body; // Add a message head to the message if message head is passed from post
       $to         = $friend_email;
       $sended     = @mail($to,$subject,$email_body,"From: $sender\nX-Mailer: PHP/".phpversion());

       if($sended) {
		            $w3->getPageObj()->setSubTitle("Email sended to your friend...TODO");
                    $home_content = "Thank you <b>\"$your_email\"</b>.<br>A segnalation email was sended to <b>\"$friend_email\"</b>,<br>thanks! TODO";
					wm3Preferences::incrementTotalSignalationsPreferences($w3);
		           }
	   else        {
					$home_content = "Email send error <b>$to</b>";//TODO
		           }
	   return $home_content;
      }
     else
      {
       $home_content = "Error: contact email already sended"; //TODO???      	
      }
     return $home_content;
    }

   public static function renderSendToFriendError($w3,$error)
    {
	 $_FIELD = webmatic3::getPostValueArray(array('newsletter_itemID','friend_email','your_email','newsletter'));
     switch($error)
      {
       case 1: // Invalid friend email
        {
         $form_title = $w3->getWord(8);
         return "message error, <b>\"".wm3Util::renderContent($w3,$_FIELD['friend_email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"</b> bad email...";
         break;
        }
       case 2: // Invalid your email
        {
         $form_title = $w3->getWord(8);
         return "message error, <b>\"".wm3Util::renderContent($w3,$_FIELD['your_email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"</b> bad email...";
         break;
        }
       default: {} // No error
      }
    }

   public static function renderContact($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(array('name','email','subject','message','newsletter'));
     $_FIELD['pageID'] = $w3->getVariable('pageID'); // Take pageID from both
	 $action = 0;
	 require(WM3_cPATH_INCLUDE.'home_contact_form.inc');
     $form->setSubmitLabel($w3->getWord(294));
     $form->setTitle("Spedisci un'email");
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['newsletter']->setValue(WM3_cENABLED);
      }
     else
      {
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_newsletters_items WRITE,
                                     ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
                                     ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
       if($form->validate())
        {
         $allowed = wm3Newsletter::addToNewsletterContact($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Newsletter::sendContact($w3,$allowed);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function addToNewsletterContact($w3)
    {
     if(wm3Session::actionAllowed($w3,$w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3,$w3->getVariable('_ID','post'));

       $_FIELD = webmatic3::getPostValueArray(array('newsletter_itemID','name','email','subject','message','newsletter'),WM3_cQUOTE_DB);

       // Subscribe email also to newsletter
       if($_FIELD['newsletter']) $enabled = WM3_cENABLED; else $enabled = WM3_cDISABLED;
	   $email = $_FIELD['email'];	   
	   wm3Newsletter::addToNewsletter($w3,$email,$enabled);
       return true;
      }
	 return false; // Protected action error
    }

   public static function sendContact($w3,$allowed,$home_link = true)
    {
	 $w3->getPageObj()->setRenderHeadFoot(false);
     if($allowed)
      {
       $_FIELD = webmatic3::getPostValueArray(array('name','email','subject','message_head','message','newsletter'),WM3_cQUOTE_DB);
       // Send the email to webmaster's email
	   $name       = $_FIELD['name'];
	   $sender     = $_FIELD['email'];
       $subject    = $_FIELD['subject'];
       $email_body = "Message from $name\n\n".$_FIELD['message_head'].$_FIELD['message']; // Add a message head to the message if message head is passed from post
       $to         = $w3->getPreferences('webmaster_email');
       $sended     = @mail($to,$subject,$email_body,"From: $sender\nX-Mailer: PHP/".phpversion());
	   if($sended)
	    {
         $home_content =  $w3->getWord(496)." $name ".$w3->getWord(1404)." <b>$to</b><br>".$w3->getWord(1745);
         if($home_link) $home_content .= "<br><br> <a href=\"".WM3_cCONFIG_HOME_FILE."\">".$w3->getWord(1746)."</a>";
	    }
	   else
	    {
		 $home_content = "Email send error <b>$to</b>";//TODO
		}
      }
     else
      {
       $home_content = "Error: contact email already sended";//TODO
      }
     return $home_content;
    }

   public static function emailExists($w3,$email)
    {
	 // Check if an email its already in the database
	 if($w3->getAction() == WM3_cACTION_EDIT_NEWSLETTER_ITEM)
	  {
	   $newsletter_itemID = $w3->getVariable('newsletter_itemID');
	   $rs = $w3->getDBObj()->query("SELECT email FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                               WHERE newsletter_itemID = '$newsletter_itemID'");
       $row = $w3->getDBObj()->fetch($rs);
  	   if($row) $old_email = $row->email; else $old_email = '';
	   if($old_email == $email) return false;
	  }
     $rs = $w3->getDBObj()->query("SELECT email FROM ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                             WHERE email = '$email'");
     if($w3->getDBObj()->totalRows($rs) == 0) return false;
	 return true;
	}

   public function addToNewsletter($w3,$email,$enabled)
    {
	 // Add $email to newsletter or update (using $enabled) an existing one
     if(!wm3Newsletter::emailExists($w3,$email))
	  {
	   $_FIELD = array('newsletter_itemID' => '',
	                   'email'             => $email,
					   'enabled'           => $enabled,
					   'languageID'        => $w3->getHomeLanguage(),
					   'ts'                => time());
       wm3Newsletter::saveNewsletterItem($w3,$_FIELD);
	  }
     else
	  {
       // If email exists will be enabled only if $enabled its true
       if($enabled) wm3Newsletter::enableNewsletterItemEmail($w3,$email);
	  }
	}

  }

?>
