<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Rss
  {

   function __construct() { }

   public static function renderHeadRss($w3,$languageID)
    {
     // Render Rss header
	 $title       = wm3Util::quoteHTML($w3->getPreferencesContents('browser_bar_title'));
	 $link        = "http://".wm3Util::quoteHTML($w3->getPreferences('site_address'));
	 $description = wm3Util::quoteHTML($w3->getPreferencesContents('title'));
	 $date        = date("D, j M Y G:i:s O",time()); // Date format is "Tue, 05 Aug 2008 13:45:00 +0200"
	 $generator   = "Webmatic ".WM3_cVERSION;
     $copyright   = wm3Util::quoteHTML($w3->getPreferencesContents('browser_bar_title'));
	 switch($languageID)
	  {
	   case WM3_cLANGUAGE_EN: { $language = "en-en"; break; }
	   case WM3_cLANGUAGE_IT: { $language = "it-it"; break; }
	   case WM3_cLANGUAGE_FR: { $language = "fr-fr"; break; }
	   case WM3_cLANGUAGE_DE: { $language = "de-de"; break; }
	   case WM3_cLANGUAGE_ES: { $language = "es-es"; break; }
	   case WM3_cLANGUAGE_NL: { $language = "nl-nl"; break; }
	   case WM3_cLANGUAGE_EL: { $language = "el-el"; break; }
	   default:               { $language = ""; }
	  }
	 header("Content-type: text/xml; charset=utf-8");
     return "<?xml version=\"1.0\" encoding=\"utf-8\"?>
             <?xml-stylesheet href=\"".WM3_cPATH_INCLUDE."rss.css\" type=\"text/css\" media=\"screen\"?>
             <rss version=\"2.0\">
			 <channel>
			 <title>$title</title>
             <link>$link</link>
             <description>$description</description>
             <pubDate>$date</pubDate>
             <generator>$generator</generator>
             <copyright>$copyright</copyright>
             <language>$language</language>";
    }

   public static function renderItemRss($w3,$title,$link,$content,$ts,$author,$comments,$category)
    {
     // Render Rss header
	 $title    = wm3Util::quoteHTML($title);
	 $link     = "http://".wm3Util::quoteHTML($w3->getPreferences('site_address')."/$link");
     $content  = str_replace(']]>',']]&gt;',$content);
	 $date     = date("D, j M Y G:i:s O",$ts); // Date format is "Tue, 05 Aug 2008 13:45:00 +0200"
	 $author   = wm3Util::quoteHTML($author);
	 $comments = "http://".wm3Util::quoteHTML($w3->getPreferences('site_address')."/$comments");
     $category = wm3Util::quoteHTML($category);
     return "<item>
	          <title>$title</title>
	          <link>$link</link>
	          <description><![CDATA[$content]]></description>
	          <pubDate>$date</pubDate>
	          <author>$author</author>
              <comments>$comments</comments>
              <category>$category</category>
             </item>";
    }

   public static function renderFootRss($w3)
    {
     // Render Rss foot
     return "</channel></rss>";
    }

  }

?>
