<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3SearchEngine
  {

   function __construct() { }

   public static function getSearchEngineItemFieldsArray()
    {
     return array('search_engine_itemID','url','keywords','description','enabled','languageID','ts');
    }

   public static function executeHomeAction($w3)
    {
     switch($w3->getAction())
      {
       default:
        {
         return wm3SearchEngine::addNewWebsite($w3);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_SEARCH_ENGINE_ITEM:
        {
         wm3SearchEngine::disableSearchEngineItem($w3,$w3->getVariable('search_engine_itemID','get'));
         return wm3SearchEngine::getSearchEngineItemList($w3,$w3->getVariable('search_engine_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_SEARCH_ENGINE_ITEM:
        {
         wm3SearchEngine::enableSearchEngineItem($w3,$w3->getVariable('search_engine_itemID','get'));
         return wm3SearchEngine::getSearchEngineItemList($w3,$w3->getVariable('search_engine_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_SEARCH_ENGINE_ITEM:
        {
         wm3SearchEngine::deleteSearchEngineItem($w3,$w3->getVariable('search_engine_itemID','get'));
         return wm3SearchEngine::getSearchEngineItemList($w3);
         break;
        }
       case WM3_cACTION_ADD_SEARCH_ENGINE_ITEM:
        {
         return wm3SearchEngine::addSearchEngineItem($w3);
         break;
        }
       case WM3_cACTION_EDIT_SEARCH_ENGINE_ITEM:
        {
         return wm3SearchEngine::editSearchEngineItem($w3);
         break;
        }
       default:
        {
         return wm3SearchEngine::getSearchEngineItemList($w3);
        }
      }
    }

   public static function getSearchEngineItemList($w3,$currentID = 0,$admin = true)
    {
     // Get search engine items list
     $max_page_items = 12;
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter) {
		          $search_link = "&filter=$filter";
     	          $query_filter = "WHERE url LIKE '%$filter%' OR description LIKE '%$filter%' OR keywords LIKE '%$filter%'";
				 }
     else        { $search_link = $query_filter = ''; }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY url";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_search_engines_items $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'search_engine_itemID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&search_engine_itemID=$row->search_engine_itemID";
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
       $_DATA[$p]->url  = "<a href=\"$row->url\" target=\"_blank\">$row->url</a>";
       $_DATA[$p]->info = "$lang_flag<br>Keywords: $row->keywords";
       // Buttons
       if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_SEARCH_ENGINE_ITEM,"action_disable.png",$w3->getWord(180));
       else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_SEARCH_ENGINE_ITEM,"action_enable.png",$w3->getWord(181));
       $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_SEARCH_ENGINE_ITEM,"action_edit.png",$w3->getWord(178));
       $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_SEARCH_ENGINE_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
       if($row->search_engine_itemID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(85));
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_search_engine_search_form.inc');
     $list->setSearchForm($search_form);
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(225),$w3->getWord(1213)));
     $list->setCaptionWidths(array(50,50));
     $list->setCaptionColspan(array(1,1,3));
     $list->setWidths(array(50,50));
     return $list->render();
    }

   public static function addSearchEngineItem($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray());
	 $action = WM3_cACTION_ADD_SEARCH_ENGINE_ITEM;
	 $search_engine_itemID = 0;
	 require(WM3_cPATH_INCLUDE.'admin_search_engine_item_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(341));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3SearchEngine::saveSearchEngineItem($w3);
         return wm3SearchEngine::getSearchEngineItemList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function editSearchEngineItem($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_SEARCH_ENGINE_ITEM;
	 $search_engine_itemID = $w3->getVariable('search_engine_itemID');
	 require(WM3_cPATH_INCLUDE.'admin_search_engine_item_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit URL");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
                               WHERE search_engine_itemID = '".$w3->getVariable('search_engine_itemID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3SearchEngine::updateSearchEngineItem($w3);
         return wm3SearchEngine::getSearchEngineItemList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function saveSearchEngineItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_search_engines_items',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateSearchEngineItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
                       SET   url                  = '".$_FIELD['url']."',
							 keywords             = '".$_FIELD['keywords']."',
							 description          = '".$_FIELD['description']."',
                             enabled              = '".$_FIELD['enabled']."',
                             languageID           = '".$_FIELD['languageID']."'
                       WHERE search_engine_itemID = '".$_FIELD['search_engine_itemID']."'");
     return $_FIELD['search_engine_itemID'];
    }

   public static function disableSearchEngineItem($w3,$search_engine_itemID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_search_engines_items SET enabled = '".WM3_cDISABLED."' WHERE search_engine_itemID = '$search_engine_itemID'");
	}

   public static function enableSearchEngineItem($w3,$search_engine_itemID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_search_engines_items SET enabled = '".WM3_cENABLED."' WHERE search_engine_itemID = '$search_engine_itemID'");
    }
   
   public static function deleteSearchEngineItem($w3,$search_engine_itemID)
    {
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_search_engines_items WHERE search_engine_itemID = '$search_engine_itemID'");
    }

   public static function renderUserSearch($w3)
    {
     // Render search panel in home page
     $link = WM3_cCONFIG_HOME_FILE;

     // Create search panel form
     $_DATA = array(); $_COLSPAN = array(); $_COLORS = array();
	 if($w3->getPreferences('show_total_search_engine'))
	  {
       $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_SEARCH_ENGINE);
       if($allowed) {
	                 $total          = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items');
	                 $total_disabled = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items',"WHERE enabled='".WM3_cDISABLED."'");
				     $total_enabled  = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items',"WHERE enabled='".WM3_cENABLED."'");
					 $label = $w3->getWord(694)." $total<br>($total_disabled disabled, $total_enabled enabled)";
			        }
       else         {
	                 $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items',"WHERE enabled='".WM3_cENABLED."'");
					 $label = $w3->getWord(694)." $total";
		            }
	   $_DATA[0]->label = '<br>'.$label;
	   $_COLSPAN[0] = array(2);
      }

     // Render form
     $filter       = $w3->getVariable('filter');
	 $filter_check = $w3->getVariable('filter_check');
     $search = new wm3GUITextField('filter',$filter,$w3->getWord(292),18);
	 $deep   = new wm3GUICheckBox ('filter_check',$filter_check,$w3->getWord(293));
     $form = new wm3GUIForm($w3,$link.'?action='.WM3_cACTION_SEARCH,'','wm3_form',array($search,$deep));
     $form->setRenderResetButton(false);
     $form->setUseWasSubmit(false);
     $form->setSubmitLabel($w3->getWord(291));

     // Render List
     $str = '';
     if(count($_DATA) > 0)
      {
       $list = new wm3GUIList($w3,$_DATA,'',$_COLSPAN,$_COLORS);
       $list->setRenderCaption(false);
       $list->setRenderPagesNavigator(false);
       $list->setWidths(array(0,100));
       $str = $list->render();
      }
     return $form->render().$str;
    }

   public static function renderUserSearchResult($w3)
    {
     // Render search result (home side)
     $max_page_items = 12;
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter) $search_link = "&filter=$filter"; else $search_link = '';
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = '';

     // Do the query and take the total items number
	 //TODO deep search che farà?
	 if(!$filter)
	  $query = "SELECT 1 LIMIT 0,0";
	 else
      $query = "SELECT
                 ".WM3_cCONFIG_DB_PREFIX."_pages.pageID      AS ID,
		         ".WM3_cCONFIG_DB_PREFIX."_pages.title       AS title_url,
		         ".WM3_cCONFIG_DB_PREFIX."_pages.render_mode AS render_mode,
		         ".WM3_cCONFIG_DB_PREFIX."_pages.subtitle    AS subtitle_keywords,
    		     ".WM3_cCONFIG_DB_PREFIX."_pages.head        AS head,
	    	     ".WM3_cCONFIG_DB_PREFIX."_pages.body        AS content,
		         ".WM3_cCONFIG_DB_PREFIX."_pages.foot        AS foot,
	    	     ".WM3_cCONFIG_DB_PREFIX."_pages.languageID  AS languageID,
		         ".WM3_cCONFIG_DB_PREFIX."_pages.enabled     AS enabled,
		         '".WM3_cSECTION_PAGES."'                    AS type
		        FROM
                 ".WM3_cCONFIG_DB_PREFIX."_pages
		        WHERE
		         ".WM3_cCONFIG_DB_PREFIX."_pages.enabled = '".WM3_cENABLED."' AND
		         (".WM3_cCONFIG_DB_PREFIX."_pages.title    LIKE '%$filter%' OR
			      ".WM3_cCONFIG_DB_PREFIX."_pages.subtitle LIKE '%$filter%' OR
			      ".WM3_cCONFIG_DB_PREFIX."_pages.head     LIKE '%$filter%' OR
			      ".WM3_cCONFIG_DB_PREFIX."_pages.body     LIKE '%$filter%' OR
			      ".WM3_cCONFIG_DB_PREFIX."_pages.foot     LIKE '%$filter%')
		   
		        UNION
		  
		        SELECT
                 ".WM3_cCONFIG_DB_PREFIX."_news.newsID      AS ID,
		         ".WM3_cCONFIG_DB_PREFIX."_news.title       AS title_url,
		         ".WM3_cCONFIG_DB_PREFIX."_news.render_mode AS render_mode,
		         ''                                         AS subtitle_keywords,
		         ''                                         AS head,
		         ".WM3_cCONFIG_DB_PREFIX."_news.news        AS content,
		         ''                                         AS foot,
		         ".WM3_cCONFIG_DB_PREFIX."_news.languageID  AS languageID,
		         ".WM3_cCONFIG_DB_PREFIX."_news.enabled     AS enabled,
		         '".WM3_cSECTION_NEWS."'                    AS type
		        FROM
                 ".WM3_cCONFIG_DB_PREFIX."_news
		        WHERE
		         ".WM3_cCONFIG_DB_PREFIX."_news.enabled = '".WM3_cENABLED."' AND
		         (".WM3_cCONFIG_DB_PREFIX."_news.title LIKE '%$filter%' OR
		          ".WM3_cCONFIG_DB_PREFIX."_news.news  LIKE '%$filter%')

                UNION

                SELECT
                 ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.search_engine_itemID AS ID,
		         ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.url                  AS title_url,
		         ''                                                                  AS render_mode,
		         ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.keywords             AS subtitle_keywords,
                 ''                                                                  AS head,
		         ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.description          AS content,
		         ''                                                                  AS foot,
		         ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.languageID           AS languageID,
		         ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.enabled              AS enabled,
		         '".WM3_cSECTION_SEARCH_ENGINE."'                                    AS type
		        FROM
                 ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
		        WHERE
		         ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.enabled = '".WM3_cENABLED."' AND
		         (".WM3_cCONFIG_DB_PREFIX."_search_engines_items.url         LIKE '%$filter%' OR
		          ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.keywords    LIKE '%$filter%' OR
		          ".WM3_cCONFIG_DB_PREFIX."_search_engines_items.description LIKE '%$filter%')
               ";
/*     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
               $query_filter";*/
	 $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items != 0) $rs = $w3->getDBObj()->query($query." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Set page subtitle
     $w3->getPageObj()->setSubTitle($w3->getWord(525)." \"".wm3Util::renderContent($w3,$filter,WM3_cRENDER_MODE_PLAIN_TEXT)."\" (".$w3->getWord(526)." $total_items)");

     // Create list content
     $_DATA = array(); $_COLSPAN = array(); $_COLORS = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {       
       $link = $base_link.$id_link.$extra_link."&search_engine_itemID=$row->ID";
	   $n = "<b>".($p+1+$max_page_items*$pg).".</b>";
	   if($row->type == WM3_cSECTION_PAGES)
        {
		 $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $url       = wm3Page::makePageLink($row->ID,$row->title_url)." ($lang_flag)"; // TODO fare target _blank
         $content   = $row->content;
		} 
	   if($row->type == WM3_cSECTION_NEWS)
        {
		 $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 $news_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_NEWS."&newsID=$row->ID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
         $url       = "<a href=\"$news_link\" target=\"_blank\">".wm3Util::renderContent($w3,$row->title_url,$row->render_mode)."</a> ($lang_flag)";
         $content   = $row->content;
		}
	   if($row->type == WM3_cSECTION_SEARCH_ENGINE)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $url     = "<a href=\"$row->title_url\" target=\"_blank\">$row->title_url</a> ($lang_flag)";
         $content = $row->content;
		}
       // Buttons
       //if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_SEARCH_ENGINE_ITEM,"action_edit.png",$w3->getWord(178));
	   $content = strip_tags($content);
	   $lenght = 250;
	   $position = stripos($content,$filter);
	   $start = $position - $lenght; if($start < 0) $start = 0;
	   $end = $position + $lenght + strlen($filter);
	   $content = substr($content,$start,$end);
	   $content = str_replace($filter,"<b>$filter</b>",$content);
	   $_DATA[2*$p]->n   = $n;
	   $_DATA[2*$p]->url = $url;
	   $_COLORS[2*$p]    = $p;
	   $_DATA[2*$p+1]->content = $content; $_COLSPAN[2*$p+1] = array(2);
	   $_COLORS[2*$p+1]        = $p;
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'',$_COLSPAN,$_COLORS);
     $list->setTotalItems($total_items);    
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$id_link.$search_link."&action=".WM3_cACTION_SEARCH);
     $list->setRenderCaption(false);
     $list->setWidths(array(0,100));
     return $list->render();
    }

   public static function addNewWebsite($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray());
     $_FIELD['pageID'] = $w3->getVariable('pageID'); // Take pageID from both
	 $action = 0;
	 require(WM3_cPATH_INCLUDE.'home_new_website_form.inc');
     $form->setSubmitLabel($w3->getWord(294));
     $form->setTitle($w3->getWord(87));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3SearchEngine::saveNewWebsite($w3);
         return wm3SearchEngine::completeNewWebsite($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function saveNewWebsite($w3)
    {
     if(wm3Session::actionAllowed($w3,$w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3,$w3->getVariable('_ID','post'));     

       $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray(),WM3_cQUOTE_DB);
       $_FIELD['enabled'] = 1;//TODO get from database
       $_FIELD['ts'] = time();
       $w3->getDBObj()->saveAllTableFields('_search_engines_items',$_FIELD);
      }
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function completeNewWebsite($w3,$lastID)
    {
	 $w3->getPageObj()->setRenderHeadFoot(false);
     if($lastID)
      {
       $_FIELD = webmatic3::getPostValueArray(wm3SearchEngine::getSearchEngineItemFieldsArray(),WM3_cQUOTE_DB);

       //TODO
       $home_content =  "Website added or updated<br><br>";
	   $home_content .= "Url: <b>".$_FIELD['url']."</b><br>";
       $home_content .= "Keywords: <b>".$_FIELD['keywords']."</b><br>";
	   $home_content .= "Description: <b>".wm3Util::renderContent($w3,$_FIELD['description'],WM3_cRENDER_MODE_PLAIN_TEXT)."</b><br>";
       $home_content .= "<br><br> <a href=\"".WM3_cCONFIG_HOME_FILE."\">Return to homepage</a>";
      }
     else
      {
       $home_content = "TODO Error di registrazione o cosa???"; // ???      	
      }
     return $home_content;
    }

  }

?>
