<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Statistic
  {

   function __construct() { }

   public static function getStatisticHistoryFieldsArray()
    {
     return array('historyID','year','day','month','hour','day_of_the_week','hits','ts');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DELETE_LOG:
        {
         wm3Logs::deleteLog($w3,$w3->getVariable('logID','get'));
		 return wm3Logs::getLogList($w3);
         break;
        }
       case WM3_cACTION_DELETE_ALL_LOG:
        {
         wm3Logs::deleteLogAll($w3);
		 return wm3Logs::getLogList($w3);
         break;
        }
       case WM3_cACTION_SHOW_LOG:
        {
         return wm3Logs::getLogList($w3);
         break;
        }
	   case WM3_cACTION_RESET_ALL_STATISTIC:
	    {
		 wm3Statistic::resetStatisticAll($w3);
		 return wm3Statistic::getStatisticBase($w3);
		 break;
		}
       case WM3_cACTION_SHOW_TREND_STATISTIC:
        {
         return wm3Statistic::getStatisticTrend($w3);
         break;
        }
       case WM3_cACTION_SHOW_HISTORY_STATISTIC:
        {
         return wm3Statistic::getStatisticHistory($w3);
         break;
        }
       default:
        {
         return wm3Statistic::getStatisticBase($w3);
        }
      }
    }

   public static function executeWebmaticInformationAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_PHP_INFORMATIONS:
        {
         return wm3Util::getPhpInformations();
         break;
        }
       default:
        {
         return wm3Statistic::getWebmaticInformations($w3);
        }
      }
    }

   public static function getStatisticBase($w3)
    {
     // Base statistics page content (home and admin side)
     $str =  wm3Statistic::renderStatisticBase($w3,"_statistics_oses",765)."<br><br>";
     $str .= wm3Statistic::renderStatisticBase($w3,"_statistics_browsers",766)."<br><br>";
     $str .= wm3Statistic::renderStatisticBase($w3,"_countries",809,15,true)."<br><br>";
	 $str .= wm3Statistic::renderStatisticBasePage($w3,814,10)."<br><br>";
	 $str .= wm3Statistic::renderStatisticBaseNews($w3,815,10)."<br><br>";
	 $str .= wm3Statistic::renderStatisticBaseDownload($w3,1092,10)."<br><br>";
	 $str .= wm3Statistic::renderStatisticBaseMiscellaneous($w3,834);
     return $str;
    }

   public static function getStatisticHistory($w3)
    {
	 // History statistics
     $yearID  = $w3->getVariable('yearID', 'get');
	 $monthID = $w3->getVariable('monthID','get');
	 $dayID   = $w3->getVariable('dayID',  'get');
	 if(!$yearID && !$monthID && !$dayID)
	  {
       $ts = time(); $yearID = date('Y',$ts); $monthID = date('n',$ts); $dayID = date('j',$ts);
	   $str  = wm3Statistic::renderStatisticHistory($w3,938, WM3_cSTATISTIC_YEARLY                                    )."<br><br>";
	   $str .= wm3Statistic::renderStatisticHistory($w3,940, WM3_cSTATISTIC_MONTHLY,      $yearID                     )."<br><br>";
	   $str .= wm3Statistic::renderStatisticHistory($w3,941, WM3_cSTATISTIC_DAILY,        $yearID,$monthID            )."<br><br>";
	   $str .= wm3Statistic::renderStatisticHistory($w3,942, WM3_cSTATISTIC_HOURLY,       $yearID,$monthID,$dayID,true)."<br><br>";
	   $str .= wm3Statistic::renderStatisticHistory($w3,1023,WM3_cSTATISTIC_WEEKLY,            '',      '',    '',true)."<br><br>";
	   $str .= wm3Statistic::renderStatisticHistory($w3,1079,WM3_cSTATISTIC_HOURLY_GLOBAL,     '',      '',    '',true)."<br><br>";

       // Maximum visitors values
	   $total_hits = wm3Statistic::getTotalVisits($w3);

       // Total visitors
       $today_visits = wm3Statistic::getTodayVisits($w3);

       // Max month
       $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT DISTINCT year, month, SUM(hits) AS hits FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history GROUP BY year, month ORDER BY hits DESC LIMIT 1"));
	   if(!$total_hits) $max_month = "---";
	   else             {
		                 $percentage = $row->hits/$total_hits*100;
	                     $ts        = mktime(0,0,0,$row->month,1,$row->year);
	                     $month     = $w3->getWordMonth(date('n',$ts));
	                     $max_month = "$month $row->year - $percentage% (".$row->hits.")";
                        }

       // Max day
       $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT DISTINCT year, month, day, SUM(hits) AS hits FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history GROUP BY year, month, day ORDER BY hits DESC LIMIT 1"));
	   if(!$total_hits) $max_day = "---";
	   else             {
		                 $percentage = $row->hits/$total_hits*100;
	                     $ts      = mktime(0,0,0,$row->month,$row->day,$row->year);
	                     $day     = wm3Util::renderDate($w3,$ts,$w3->getAdminLanguage(),true,'',false,true);
	                     $max_day = "$day - $percentage% (".$row->hits.")";
                        }

       // Max hour
       $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history WHERE hits = (SELECT MAX(hits) AS max FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history)"));
	   if(!$total_hits) $max_hour = "---";
	   else             {
		                 $percentage = $row->hits/$total_hits*100;
	                     $ts       = mktime($row->hour,0,0,$row->month,$row->day,$row->year);
	                     $date     = wm3Util::renderDate($w3,$ts,$w3->getAdminLanguage(),true,'',false,true);
	                     $hour     = date('H',$ts);
	                     $max_hour = "$hour:00:00-$hour:59:59 [$date] - $percentage% (".$row->hits.")";
					    }

	   // Daily average
       $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT DISTINCT year, month, day FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history GROUP BY year, month, day ORDER BY year, month, day LIMIT 1"));
	   if(!$total_hits) $average = 0;
	   else             {
                         $end_ts     = time();
                         $start_ts   = mktime(0,0,0,$row->month,$row->day,$row->year);
                         $total_days = intval(($end_ts - $start_ts) / 86400) + 1;
						 $average = $total_hits / $total_days;
                        }
	   $average_day = "$average ".$w3->getWord(1021);

       // Max visitors/Users
       $max_visitors = wm3Statistic::getCounterMaxVisitors($w3);
	   $max_users    = wm3Statistic::getCounterMaxUsers($w3);
       $max_visitors_users = "<img src=\"".WM3_cPATH_DATA."misc_visitor.png\" width=\"16\" height=\"16\"> = $max_visitors<br><img src=\"".WM3_cPATH_DATA."misc_user.png\" width=\"16\" height=\"16\"> = $max_users";

       // Last connected user informations
	   $last_user_login = wm3User::getUserLogin($w3,wm3Statistic::getCounterLastUserID($w3)); if(!$last_user_login) $last_user_login = $w3->getWord(988);
       $last_user = "<b>IP:</b> ".wm3Statistic::getCounterLastUserIp($w3)." (".wm3Statistic::getCounterLastUserDns($w3).")<br>
	                 <b>".$w3->getWord(1099)."</b> $last_user_login<br>
					 <b>".$w3->getWord(1100)."</b> ".wm3Util::renderDate($w3,wm3Statistic::getCounterLastUserTs($w3),$w3->getAdminLanguage(),true,'',true,true);

       // Create list items
	   $_DATA = array();
       $_DATA[0]->label = $w3->getWord(-1)."Total visitors:"; $_DATA[0]->info = "$total_hits ($today_visits today)";
	   $_DATA[1]->label = $w3->getWord(965);  $_DATA[1]->info = $max_month;
	   $_DATA[2]->label = $w3->getWord(966);  $_DATA[2]->info = $max_day;
	   $_DATA[3]->label = $w3->getWord(967);  $_DATA[3]->info = $max_hour;
	   $_DATA[4]->label = $w3->getWord(1290); $_DATA[4]->info = $average_day;
	   $_DATA[5]->label = $w3->getWord(1020); $_DATA[5]->info = $max_visitors_users;
	   $_DATA[6]->label = $w3->getWord(1080); $_DATA[6]->info = $last_user;
	   $_DATA[7]->label = $w3->getWord(1765); $_DATA[7]->info = wm3Util::renderDate($w3,wm3Statistic::getCounterInstallationTS($w3),$w3->getAdminLanguage(),true,'',true,true);

       // Render List
       $list = new wm3GUIList($w3,$_DATA,$w3->getWord(964));
       $list->setRenderCaption(false);
       $list->setRenderPagesNavigator(false);
       $list->setWidths(array(40,60));
       $str .= $list->render();
      }
     else
	  {
	   if($yearID && !$monthID && !$dayID) // Yearly statistics (12 months)
	    $str = wm3Statistic::renderStatisticHistory($w3,940,WM3_cSTATISTIC_MONTHLY,$yearID);
	   if($yearID && $monthID && !$dayID)  // Monthly statistics (from 28 to 31 days)
	    $str = wm3Statistic::renderStatisticHistory($w3,941,WM3_cSTATISTIC_DAILY,$yearID,$monthID);
	   if($yearID && $monthID && $dayID)   // Daily statistics (24 hours)
	    $str = wm3Statistic::renderStatisticHistory($w3,942,WM3_cSTATISTIC_HOURLY,$yearID,$monthID,$dayID);
      }

     return $str;
    }

   public static function getStatisticTrend($w3)
    {
	 // Trend statistics

  	 // Statistics search form
	 require(WM3_cPATH_INCLUDE.'admin_statistic_trend_search_form.inc');
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $ts = time(); 
       $start_ts = $ts - 604800; $start_day = date("d",$start_ts); $start_month = date("m",$start_ts); $start_year = date("o",$start_ts); $start_hour = date("G",$start_ts);
	   $end_ts   = $ts;          $end_day   = date("d",$end_ts);   $end_month   = date("m",$end_ts);   $end_year   = date("o",$end_ts);   $end_hour   = date("G",$end_ts);
       $step = 1; $zoom = 2;
      }
     else
      {
       $start_day = $w3->getVariable('start_day','post'); $start_month = $w3->getVariable('start_month','post'); $start_year = $w3->getVariable('start_year','post'); $start_hour = $w3->getVariable('start_hour','post');
       $end_day   = $w3->getVariable('end_day','post');   $end_month   = $w3->getVariable('end_month','post');   $end_year   = $w3->getVariable('end_year','post');   $end_hour   = $w3->getVariable('end_hour','post');
       $step      = $w3->getVariable('step','post');      $zoom        = $w3->getVariable('zoom','post');
      }
     $_F['start']->setDateYMD($start_year,$start_month,$start_day);
     $_F['end']->setDateYMD($end_year,$end_month,$end_day);
     $_F['start_hour']->setValue($start_hour);
     $_F['end_hour']->setValue($end_hour);
     $_F['step']->setValue($step);
     $_F['zoom']->setValue($zoom);
     if(!$form->validate())
      {
	   $error = 1;
       $title = "<b>Bad date format</b>";
	  }
	 else
	  {
	   $error = 0;
	   $start_ts = mktime($start_hour,0,0,$start_month,$start_day,$start_year);
       $end_ts   = mktime($end_hour,59,59,$end_month,$end_day,$end_year);
       $start_date = wm3Util::renderDate($w3,$start_ts,$w3->getAdminLanguage());
	   $end_date   = wm3Util::renderDate($w3,$end_ts,$w3->getAdminLanguage());
       $title = "<b>".$w3->getWord(946)." $start_date ".$w3->getWord(947)." $end_date</b>";
      }
     return wm3Statistic::renderStatisticTrend($w3,946,$title,$start_day,$start_month,$start_year,$start_hour,$end_day,$end_month,$end_year,$end_hour,$step,$zoom,$form->render(),$error);
	}

   public static function renderStatisticBase($w3,$table,$label,$max_items=0,$is_flag=false)
    {
     // Get base browsers/OSes/countries statistics list

     // Prepare variables to create the list

     // Do the query and take the total items number
     $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT SUM(hits) AS total_hits
                                                 FROM ".WM3_cCONFIG_DB_PREFIX."$table"));
     $total_hits = $row->total_hits;
     if($max_items) $limit = "LIMIT 0,$max_items"; else $limit = '';
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM   ".WM3_cCONFIG_DB_PREFIX."$table
                             ORDER BY hits DESC $limit");
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = $_BAR_HORIZONTAL = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       if($is_flag) { $icon = WM3_cPATH_FLAGS.$row->code.".gif"; $w = 20; $h = 13; }
       else         { $icon = WM3_cPATH_DATA.$row->icon;         $w = 36; $h = 36; }
       $hits = $row->hits;
       if(!$total_hits) $percentage = 0; else $percentage = $hits/$total_hits*100;
       $_DATA[$p]->icon = "<nobr><img src=\"$icon\" border=\"0\" align=\"absmiddle\" width=\"$w\" height=\"$h\"> $row->name</nobr>";
       $_DATA[$p]->bar  = wm3Util::makePercentageBar($w3,$percentage,300,14)." ".round($percentage,2)."% ($hits)";
       $_BAR_HORIZONTAL[$p] = 1;
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord($label));
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(0,100));
     $list->setBarHorizontal($_BAR_HORIZONTAL);
     return $list->render();
    }

   public static function renderStatisticBasePage($w3,$label,$max_items=0)
    {
     // Get base pages statistics list

     // Prepare variables to create the list
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES); // Used to enable admin buttons
	 if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_PAGES;

     // Do the query and take the total items number
	 $where = "WHERE enabled = '".WM3_cENABLED."'";
     $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT SUM(hits) AS total_hits
                                                 FROM ".WM3_cCONFIG_DB_PREFIX."_pages
												 $where"));
     $total_hits = $row->total_hits;
     if($max_items) $limit = "LIMIT 0,$max_items"; else $limit = '';
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM   ".WM3_cCONFIG_DB_PREFIX."_pages
							 $where
                             ORDER BY hits DESC $limit");
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = $_BAR_HORIZONTAL = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $hits = $row->hits;
       if(!$total_hits) $percentage = 0; else $percentage = $hits/$total_hits*100;
       $link = wm3Page::makePageLink($row->pageID,$row->title);
	   if($allowed) $allowed_link = $base_allowed_link."&pageID=$row->pageID";
       $_DATA[$p]->link = "<nobr>$link</nobr>";
       $_DATA[$p]->bar  = wm3Util::makePercentageBar($w3,$percentage,300,14)." ".round($percentage,2)."% ($hits)";
	   if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_PAGE,"action_edit.png",$w3->getWord(178));
	   $_BAR_HORIZONTAL[$p] = 1;
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord($label));
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(0,100));
     $list->setBarHorizontal($_BAR_HORIZONTAL);
     return $list->render();
    }

   public static function renderStatisticBaseNews($w3,$label,$max_items=0)
    {
     // Get base news statistics list

     // Prepare variables to create the list
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS); // Used to enable admin buttons
	 if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_NEWS;

     // Do the query and take the total items number
	 $where = "WHERE enabled='".WM3_cENABLED."'";
     $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT SUM(hits) AS total_hits
                                                 FROM ".WM3_cCONFIG_DB_PREFIX."_news
												 $where"));
     $total_hits = $row->total_hits;
     if($max_items) $limit = "LIMIT 0,$max_items"; else $limit = "";
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM   ".WM3_cCONFIG_DB_PREFIX."_news
							 $where
                             ORDER BY hits DESC $limit");
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = $_BAR_HORIZONTAL = array(); $p = 0;
     if($allowed) $_WIDTHS = array(0,100,0); else $_WIDTHS = array(0,100);
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $hits = $row->hits;
       if(!$total_hits) $percentage = 0; else $percentage = $hits/$total_hits*100;
       $link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_NEWS."&newsID=$row->newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
	   if($allowed) $allowed_link = $base_allowed_link."&newsID=$row->newsID";
       $_DATA[$p]->link = "<nobr><a href=\"$link\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a></nobr>";
       $_DATA[$p]->bar  = wm3Util::makePercentageBar($w3,$percentage,300,14)." ".round($percentage,2)."% ($hits)";
	   if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_NEWS,"action_edit.png",$w3->getWord(178));
	   $_BAR_HORIZONTAL[$p] = 1;
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord($label));
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(0,100));
     $list->setBarHorizontal($_BAR_HORIZONTAL);
     return $list->render();
    }


   public static function renderStatisticBaseDownload($w3,$label,$max_items=0)
    {
     // Get base downloads statistics list

     // Prepare variables to create the list
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DOWNLOADS); // Used to enable admin buttons
	 if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DOWNLOADS;

     // Do the query and take the total items number
	 $where = "WHERE ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.categoryID AND
                     ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID
                 AND ".WM3_cCONFIG_DB_PREFIX."_downloads.enabled * ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled * ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled = '".WM3_cENABLED."'";
     $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT SUM(hits) AS total_hits
                                                 FROM ".WM3_cCONFIG_DB_PREFIX."_downloads,
											      	  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories,
												      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories
												 $where"));
     $total_hits = $row->total_hits;
     if($max_items) $limit = "LIMIT 0,$max_items"; else $limit = '';
     $rs = $w3->getDBObj()->query("SELECT ".WM3_cCONFIG_DB_PREFIX."_downloads.*
                             FROM   ".WM3_cCONFIG_DB_PREFIX."_downloads,
							        ".WM3_cCONFIG_DB_PREFIX."_downloads_categories,
									".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories
							 $where
                             ORDER BY hits DESC $limit");
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = $_BAR_HORIZONTAL = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $hits = $row->hits;
       if(!$total_hits) $percentage = 0; else $percentage = $hits/$total_hits*100;
	   if($allowed) $allowed_link = $base_allowed_link."&downloadID=$row->downloadID";
       $_DATA[$p]->name = "<nobr>$row->name</nobr>";
       $_DATA[$p]->bar  = wm3Util::makePercentageBar($w3,$percentage,300,14)." ".round($percentage,2)."% ($hits)";
	   if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DOWNLOAD,"action_edit.png",$w3->getWord(178));
       $_BAR_HORIZONTAL[$p] = 1;
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord($label));
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(0,100));
     $list->setBarHorizontal($_BAR_HORIZONTAL);
     return $list->render();
    }

   public static function renderStatisticBaseMiscellaneous($w3,$label)
    {
     // Get miscellaneous base statistics list

     // Prepare variables to create the list
     $_DATA = array();

     // News
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS); // Used to enable admin buttons
	 $title = wm3Util::renderImg("icon_news.png",'',32,32)." ".$w3->getWord(17);
	 if($allowed) {
		           $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_news');
                   $total_disabled = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_news',"WHERE enabled='".WM3_cDISABLED."'");
				   $total_enabled  = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_news',"WHERE enabled='".WM3_cENABLED."'");
				   $info = $total." ($total_disabled disabled, $total_enabled enabled)";
			      }
     else $info = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_news',"WHERE enabled='".WM3_cENABLED."'");
     $_DATA[0]->label = "<nobr>$title</nobr>"; $_DATA[0]->info = $info;

     // Users
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_USERS); // Used to enable admin buttons
	 $title = wm3Util::renderImg("icon_users.png",'',32,32)." ".$w3->getWord(19);
	 if($allowed) {
	               $total               = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_users');
	               $total_standard      = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE admin='".WM3_cDISABLED."'");
	               $total_administrator = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE admin='".WM3_cENABLED."' AND superuser='".WM3_cDISABLED."'");
	               $total_superuser     = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE superuser='".WM3_cENABLED."'");
				   $total_disabled      = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE enabled='".WM3_cDISABLED."' OR deleted='".WM3_cENABLED."'");
				   $total_enabled       = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE enabled='".WM3_cENABLED."' AND deleted='".WM3_cDISABLED."'");
	               $last_user = "Newest member: ";
				   $login = "login";//TODO
	               $last_user .= "<a href=\"xxx\">$login</a>";
				   $info = $total." ($total_standard standard, $total_administrator administrators, $total_superuser superuser) ($total_disabled disabled, $total_enabled enabled)<br>$last_user";
				  }
     else         {
	               $total               = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE enabled='".WM3_cENABLED."' AND deleted='".WM3_cDISABLED."'");
	               $total_standard      = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE admin='".WM3_cDISABLED."' AND enabled='".WM3_cENABLED."' AND deleted='".WM3_cDISABLED."'");
	               $total_administrator = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_users',"WHERE admin='".WM3_cENABLED."' AND enabled='".WM3_cENABLED."' AND deleted='".WM3_cDISABLED."'");
				   $info = $total." ($total_standard standard, $total_administrator administrators)";
			      }
     $_DATA[1]->label = "<nobr>$title</nobr>"; $_DATA[1]->info = $info;

     // Newsletter
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWSLETTER); // Used to enable admin buttons
	 $title = wm3Util::renderImg("icon_newsletter.png",'',32,32)." ".$w3->getWord(11);
	 if($allowed) {
	               $total          = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items');
	               $total_disabled = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items',"WHERE enabled='".WM3_cDISABLED."'");
				   $total_enabled  = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items',"WHERE enabled='".WM3_cENABLED."'");
				   $info = $total." ($total_disabled disabled, $total_enabled enabled)";
			      }
     else $info = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_newsletters_items',"WHERE enabled='".WM3_cENABLED."'");
     $_DATA[2]->label = "<nobr>$title</nobr>"; $_DATA[2]->info = $info;

     // Search
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_SEARCH_ENGINE); // Used to enable admin buttons
	 $title = wm3Util::renderImg("icon_searchengine.png",'',32,32)." ".$w3->getWord(13);
	 if($allowed) {
	               $total          = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items');
	               $total_disabled = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items',"WHERE enabled='".WM3_cDISABLED."'");
				   $total_enabled  = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items',"WHERE enabled='".WM3_cENABLED."'");
				   $info = $total." ($total_disabled disabled, $total_enabled enabled)";
		          }
	 else $info = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_search_engines_items',"WHERE enabled='".WM3_cENABLED."'");
     $_DATA[3]->label = "<nobr>$title</nobr>"; $_DATA[3]->info = $info;

     // Links
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_SEARCH_ENGINE); // Used to enable admin buttons
	 $title = wm3Util::renderImg("icon_links.png",'',32,32)." ".$w3->getWord(18);
	 if($allowed) {//TODO fare query considerando anche le categorie...
		           $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_links');
	               $total_disabled = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.'_links',"WHERE enabled='".WM3_cDISABLED."'");
				   $info = $total." (Disabled $total_disabled)????";
				  }
	 else $info = "?";
     $_DATA[4]->label = "<nobr>$title</nobr>"; $_DATA[4]->info = $info;

     // Signalations
	 $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_STATISTICS); // Used to enable admin buttons
	 if($allowed)
	  {
	   $title = wm3Util::renderImg("icon_messages.png",'',32,32)." ".$w3->getWord(25);
	   $info  = wm3Preferences::loadTotalSignalations($w3);
       $_DATA[5]->label = "<nobr>$title</nobr>"; $_DATA[5]->info = $info;
      }

/*Site visitors: 3(0) //c'è gia in statistiche cronologiche
Number of items in the F.A.Q. section: 0
Number of items in the little market: 0
Number of banners in the database: 0
Number of horoscopes: 0
The banners are: OFF*/

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord($label));
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(15,85));
     if($allowed) $list->setBarHorizontal(array(1,1,1,1,1));
     else         $list->setBarHorizontal(array(1,1,1,1,1,1));
     return $list->render();
    }

   public static function renderStatisticHistory($w3,$label,$type,$year = '',$month = '', $day = '', $no_link = false)
    {
     // Get history statistics range list

     // Prepare variables to create the list
	 $label = $w3->getWord($label);
	 $link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_STATISTICS."&action=".WM3_cACTION_SHOW_HISTORY_STATISTIC;
	 if($type == WM3_cSTATISTIC_YEARLY)        { $field = 'year';            $filter = "";														     $s = wm3Statistic::getMinYear($w3); $n = wm3Statistic::getMaxYear($w3);                    $columns = $n - $s + 2; $_LABELS = array();                                       $array_offset = 1; $link .= "&yearID=";                                                                                                                                              }
	 if($type == WM3_cSTATISTIC_MONTHLY)       { $field = 'month';           $filter = "WHERE year = '$year'";                                       $s = 1;                             $n = 12;                                            $columns = $n + 1;      $_LABELS = $w3->getLanguageObj()->getArrayMonth();        $array_offset = 1; $link .= "&yearID=$year&monthID=";              $label .= " $year:";                                                                                              }
	 if($type == WM3_cSTATISTIC_DAILY)         { $field = 'day';             $filter = "WHERE year = '$year' AND month = '$month'"; 				 $s = 1;                             $n = cal_days_in_month(CAL_GREGORIAN,$month,$year); $columns = $n + 1;      $_LABELS = array();                                       $array_offset = 1; $link .= "&yearID=$year&monthID=$month&dayID="; $label .= " ".$w3->getWordMonth($month)." $year:";                                                                }
	 if($type == WM3_cSTATISTIC_HOURLY)        { $field = 'hour';            $filter = "WHERE year = '$year' AND month = '$month' AND day = '$day'"; $s = 0;                             $n = 23;                                            $columns = $n + 2;      $_LABELS = wm3Statistic::getArrayHour();                  $array_offset = 0;                                                 $label .= " ".wm3Util::renderDate($w3,mktime(0,0,0,$month,$day,$year),$w3->getAdminLanguage(),true,'',false).":"; }
	 if($type == WM3_cSTATISTIC_WEEKLY)        { $field = 'day_of_the_week'; $filter = ""; 														     $s = 1;                             $n = 7;                                             $columns = $n + 1;      $_LABELS = $w3->getLanguageObj()->getArrayDayOfTheWeek(); $array_offset = 1;                                                                                                                                                                   }
	 if($type == WM3_cSTATISTIC_HOURLY_GLOBAL) { $field = 'hour';            $filter = "";                                                           $s = 0;                             $n = 23;                                            $columns = $n + 2;      $_LABELS = wm3Statistic::getArrayHour();                  $array_offset = 0;                                                                                                                                                                   }

     // Do the query and take the total items number
	 $total_hits = wm3Statistic::getTotalVisits($w3);
     $rs = $w3->getDBObj()->query("SELECT SUM(hits) AS hits,$field
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_statistics_history
							 $filter
							 GROUP BY $field
							 ORDER BY $field");
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = $_WIDTHS = array();
	 $row = $w3->getDBObj()->fetch($rs,false);
	 $max_percentage = 0;
	 /*for($i = $s; $i <= $n; $i++)
	  {
	   $current_percentage = round($percentage,2)
	   if() $max_percentage = print_r($row);
      }*/
     for($i = $s; $i <= $n; $i++)
	  {
       if($row[$field] == $i)
        {
         $hits = $row['hits'];
		 $row  = $w3->getDBObj()->fetch($rs,false);
	    }
	   else $hits = 0;
	   if(!$total_hits) $percentage = 0; else $percentage = $hits/$total_hits*100;
	   if(!$no_link) { $a_open = "<a href=\"$link$i\">"; $a_close = "</a>"; } else { $a_open = $a_close = ""; }
	   $f = "f$i";
       if($_LABELS) $_DATA[0]->$f = $a_open.$_LABELS[$i-$array_offset].$a_close;
	   else         $_DATA[0]->$f = $a_open.$i.$a_close;//$row[$field];
       $_DATA[1]->$f = wm3Util::makePercentageBar($w3,$percentage,12,180,false);
	   $_DATA[2]->$f = round($percentage,2)."%<br>($hits)";
	   array_push($_WIDTHS,0);
	  }
	 $f = "f$i";
	 $_DATA[0]->$f = $_DATA[1]->$f = $_DATA[2]->$f = '';
	 array_push($_WIDTHS,100);

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$label);
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths($_WIDTHS);
     $list->setBarVertical(array(1,1,1));
     return $list->render();
    }

   public static function renderStatisticTrend($w3,$label,$title,$start_day,$start_month,$start_year,$start_hour,$end_day,$end_month,$end_year,$end_hour,$step,$zoom,$search_form,$error)
    {
     // Get statistics trends list

     // Prepare variables to create the list
     if(!$error)
      {
	   $start_ts = strtotime("$start_day-$start_month-$start_year $start_hour:00");
	   $end_ts   = strtotime("$end_day-$end_month-$end_year $end_hour:00");
       if($step == WM3_cSTATISTIC_TREND_STEP_HOUR)
	    {
	     $field = 'hour'; $filter = '';
	     $n = ($end_ts - $start_ts) / 60 / 60;
	    }
	   else
	    {
	     $field = 'day';  $filter = '';
	     $n = ($end_ts - $start_ts) / 60 / 60 / 24;
	    }
	   $columns = $n + 1;

       // Do the query and take the total items number
       $total_hits = wm3Statistic::getTotalVisits($w3);
       $rs = $w3->getDBObj()->query("SELECT SUM(hits) AS hits,$field
                               FROM   ".WM3_cCONFIG_DB_PREFIX."_statistics_history
	                           $filter
		                       GROUP BY $field
		  					   ORDER BY $field");
       $total_items = $w3->getDBObj()->totalRows($rs);
      }
     // Create list content
     $_DATA = $_VALUES = $_LABELS = array();
     if(!$error)
      {
	   $row = $w3->getDBObj()->fetch($rs,false);
       for($i = 1; $i <= $n; $i++)
	    {
         if($row[$field] == $i)
          {
           $hits = $row['hits'];
	  	   $row = $w3->getDBObj()->fetch($rs,false);
	      }
	     else $hits = 0;
	     if(!$total_hits) $percentage = 0; else $percentage = $hits/$total_hits*100;
	     $alt = round($percentage,2)."% ($hits)";
         array_push($_VALUES,$percentage);
         array_push($_LABELS,$alt);
	    }
       $_DATA[0]->content = wm3Statistic::renderHistogram($w3,$_VALUES,$_LABELS,$zoom);
      }
     else $_DATA[0]->content = '';
     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord($label));
     $list->setSearchForm($search_form);
     $list->setCaptionLabels(array($title));
     $list->setCaptionWidths(array(100));
     $list->setCaptionColspan(array(1));
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(100));
     return $list->render();
    }

   public static function renderHistogram($w3,$_VALUES,$_LABELS,$zoom)
    {
     // Draw $_VALUES as an histogram

     // Create list content
     $_DATA = $_WIDTHS = array();
     for($i = 0; $i < count($_VALUES); $i++)
	  {
	   $f = "f$i";
       $_DATA[0]->$f = wm3Util::makePercentageBar($w3,$_VALUES[$i],1*$zoom,100*$zoom,false,$_LABELS[$i]);
	   $_DATA[1]->$f = '';
	   array_push($_WIDTHS,0);
	  }
	 $f = "f$i";
	 $_DATA[0]->$f = $_DATA[1]->$f = '';
	 array_push($_WIDTHS,100);

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setRenderPagesNavigator(false);
     $list->setRenderCaption(false);
     $list->setWidths($_WIDTHS);
     $list->setBarVertical(array(1,1));
     return $list->render();
    }

   public static function updateStatisticBrowser($w3)
    {
     // Update statistics for the browsers
	 $user_agent = getenv('HTTP_USER_AGENT');
     if    (preg_match("/bot/i",      $user_agent) ||
            preg_match("/Google/",    $user_agent) ||
            preg_match("/Slurp/",     $user_agent) ||
            preg_match("/Scooter/",   $user_agent) ||
            preg_match("/Spider/i",   $user_agent) ||
            preg_match("/Infoseek/i", $user_agent)) $browser = WM3_cBROWSER_SEARCH_ENGINE;
     elseif((preg_match("/Nav/",         $user_agent)  ||
	         preg_match("/Gold/",        $user_agent)  ||
			 preg_match("/X11/",         $user_agent)  ||
			 preg_match("/Netscape/",    $user_agent)) &&
			 (!preg_match("/Mozilla/",   $user_agent)  &&
			  !preg_match("/MSIE/",      $user_agent)  &&
			  !preg_match("/Konqueror/", $user_agent))) $browser = WM3_cBROWSER_NETSCAPE;
     elseif(preg_match("/MSIE/",      $user_agent))  $browser = WM3_cBROWSER_IE;
	 elseif(preg_match("/Chrome/",    $user_agent))  $browser = WM3_cBROWSER_CHROME;
	 elseif(preg_match("/Mozilla/",   $user_agent))  $browser = WM3_cBROWSER_MOZILLA;
     elseif(preg_match("/Lynx/",      $user_agent))  $browser = WM3_cBROWSER_LYNX;
     elseif(preg_match("/Opera/",     $user_agent))  $browser = WM3_cBROWSER_OPERA;
     elseif(preg_match("/WebTV/",     $user_agent))  $browser = WM3_cBROWSER_WEBTV;
     elseif(preg_match("/Konqueror/", $user_agent))  $browser = WM3_cBROWSER_KONQUEROR;
     elseif(preg_match("/IBrowse/",   $user_agent))  $browser = WM3_cBROWSER_IBROWSE;
     else                                     $browser = WM3_cBROWSER_OTHER;
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_statistics_browsers SET hits = hits + 1 WHERE  browserID = '$browser'");
    }

   public static function updateStatisticOS($w3)
    {
     // Update statistics for OSes
	 $user_agent = getenv('HTTP_USER_AGENT');
	 if    (preg_match("/Mac/",    $user_agent)  ||
	        preg_match("/PPC/",    $user_agent)) $os = WM3_cOS_MACOS;
     elseif(preg_match("/Win/",    $user_agent)) $os = WM3_cOS_WINDOWS;
     elseif(preg_match("/Linux/",  $user_agent)) $os = WM3_cOS_LINUX;
     elseif(preg_match("/FreeBSD/",$user_agent)) $os = WM3_cOS_FREEBSD; //TODO controllare
     elseif(preg_match("/SunOS/",  $user_agent)) $os = WM3_cOS_SUNOS;
     elseif(preg_match("/IRIX/",   $user_agent)) $os = WM3_cOS_IRIX; //TODO controllare
     elseif(preg_match("/BeOS/",   $user_agent)) $os = WM3_cOS_BEOS;
     elseif(preg_match("/OS\/2/",  $user_agent)) $os = WM3_cOS_OS2; //TODO controllare
     elseif(preg_match("/AIX/",    $user_agent)) $os = WM3_cOS_AIX;
     elseif(preg_match("/Amiga/",  $user_agent)) $os = WM3_cOS_AMIGAOS;
     else                                        $os = WM3_cOS_OTHER;
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_statistics_oses SET hits = hits + 1 WHERE osID = '$os'");
    }

   function updateStatisticCountry($w3)
    {
     $hostname = gethostbyaddr(getenv('REMOTE_ADDR'));
     $code     = strtolower(substr(strrchr($hostname,'.'),1));
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_countries SET hits = hits + 1 WHERE code = '$code'");
    }

   public static function updateStatisticHistory($w3)
    {
     // Update statistics history
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_statistics_history WRITE");
	 $_FIELD = webmatic3::getPostValueArray(wm3Statistic::getStatisticHistoryFieldsArray());
     $ts = time();
	 $_FIELD['year']            = date('Y',$ts);
	 $_FIELD['month']           = date('n',$ts);
	 $_FIELD['day']             = date('j',$ts);
	 $_FIELD['hour']            = date('G',$ts);
	 $_FIELD['day_of_the_week'] = date('N',$ts);
	 $_FIELD['hits']            = 1;
	 $_FIELD['ts']              = $ts;
     $rs = $w3->getDBObj()->query("SELECT historyID FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history WHERE year = '".$_FIELD['year']."' AND month = '".$_FIELD['month']."' AND day = '".$_FIELD['day']."' AND hour = '".$_FIELD['hour']."' AND day_of_the_week = '".$_FIELD['day_of_the_week']."'");
	 if($w3->getDBObj()->totalRows($rs) == 0) {
	                               $w3->getDBObj()->saveAllTableFields('_statistics_history',$_FIELD);
                                  }
	 else                         {
		                           $row = $w3->getDBObj()->fetch($rs);
	                               $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_statistics_history
                                                        SET hits = hits + 1
                                                      WHERE historyID = '$row->historyID'");
								  }
     $w3->getDBObj()->query("UNLOCK TABLES");
    }

   public static function getCountryFlag($w3,$countryID)
    {
     $rs = $w3->getDBObj()->query("SELECT code FROM ".WM3_cCONFIG_DB_PREFIX."_countries
                             WHERE countryID = '$countryID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return "_unknown.gif";
     $row = $w3->getDBObj()->fetch($rs);
     return $row->code.".gif";
    }

   public static function getCountryName($w3,$countryID)
    {
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_countries
                             WHERE countryID = '$countryID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return $w3->getWord(1139);
     $row = $w3->getDBObj()->fetch($rs);
     return $row->name;
    }

   public static function getArrayHour($separator = '<br>')
    {
	 $_ARRAY = array();
	 for($i = 0;  $i <= 9;  $i++) array_push($_ARRAY,"0".$i.":00".$separator."0".$i.":59");
	 for($i = 10; $i <= 23; $i++) array_push($_ARRAY,$i.":00".$separator.$i.":59");
	 return $_ARRAY;
	}

   public static function getMaxYear($w3)
    {
     $rs = $w3->getDBObj()->query("SELECT MAX(year) AS max FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history");
     if($w3->getDBObj()->totalRows($rs) != 1) return "";
     $row = $w3->getDBObj()->fetch($rs);
     return $row->max;
    }

   public static function getMinYear($w3)
    {
     $rs = $w3->getDBObj()->query("SELECT MIN(year) AS min FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history");
     if($w3->getDBObj()->totalRows($rs) != 1) return "";
     $row = $w3->getDBObj()->fetch($rs);
     return $row->min;
    }

   public static function getTotalVisits($w3)
    {
     $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT SUM(hits) AS total FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history"));
     if($row->total) return $row->total; else return 0;
    }

   public static function getTodayVisits($w3)
    {
	 $ts = time();
	 $year = date('Y',$ts); $month = date('n',$ts); $day = date('j',$ts);
     $rs = $w3->getDBObj()->query("SELECT SUM(hits) AS total
	                           FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history
							  WHERE day = '$day' AND month = '$month' AND year = '$year'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row->total) return $row->total; else return 0;
    }

   public static function getCounterMaxVisitors($w3)
    {
     $rs = $w3->getDBObj()->query("SELECT max_visitors FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->max_visitors;
    }

   public static function getCounterMaxUsers($w3)
    {
     $rs = $w3->getDBObj()->query("SELECT max_users FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->max_users;
    }

   public static function getCounterLastUserIp($w3)
    {
     $rs = $w3->getDBObj()->query("SELECT last_user_ip FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if($w3->getDBObj()->totalRows($rs) != 1) return '';
     $row = $w3->getDBObj()->fetch($rs);
     return $row->last_user_ip;
    }

   public static function getCounterLastUserDns($w3)
    {
     $rs = $w3->getDBObj()->query("SELECT last_user_dns FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if($w3->getDBObj()->totalRows($rs) != 1) return '';
     $row = $w3->getDBObj()->fetch($rs);
     return $row->last_user_dns;
    }

   public static function getCounterLastUserID($w3)
    {
     $rs = $w3->getDBObj()->query("SELECT last_userID FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->last_userID;
    }

   public static function getCounterLastUserTs($w3)
    {
     $rs = $w3->getDBObj()->query("SELECT last_user_ts FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->last_user_ts;
    }

   public static function getCounterInstallationTS($w3)
    {
     $rs = $w3->getDBObj()->query("SELECT installation_ts FROM ".WM3_cCONFIG_DB_PREFIX."_counters");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->installation_ts;
    }

   public static function resetStatisticAll($w3)
    {
	 // Reset all statistics and users ratings
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_statistics_browsers SET hits = 0");
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_statistics_oses     SET hits = 0");
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_countries           SET hits = 0");
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages               SET hits = 0");
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news                SET hits = 0");//TODO resettare anche votes_counts,votes_sum e votes_average quando saranno presenti, in futuro, anche nella tabella _news
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads           SET hits = 0");
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items   SET hits = 0, votes_counts = 0, votes_sum = 0, votes_average = 0");
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items  SET hits = 0, votes_counts = 0, votes_sum = 0, votes_average = 0");
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
	                      SET total_visitors     = 0,
						      total_signalations = 0,
							  max_visitors       = 0,
							  max_users          = 0,
							  last_user_ip       = '',
							  last_user_dns      = '',
							  last_userID 	     = 0,
							  last_user_ts       = 0");
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_statistics_history");
	}

   public static function selectStatisticHour($w3)
    {
     // Return an array of wm3GUIOption objects for statistic hours select
     return wm3Util::selectArray(wm3Statistic::getArrayHour('-'),
                                 array('0','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22','23'));
    }

   public static function selectStatisticStep($w3)
    {
     // Return an array of wm3GUIOption objects for statistic step select
     return wm3Util::selectArray(array($w3->getWord(960),$w3->getWord(961)),
                                 array(WM3_cSTATISTIC_TREND_STEP_HOUR,WM3_cSTATISTIC_TREND_STEP_DAY));
    }

   public static function selectStatisticZoom($w3)
    {
     // Return an array of wm3GUIOption objects for statistic zoom select
     return wm3Util::selectArray(array('x1','x2','x3','x4'),
                                 array('1','2','3','4'));
    }

   public static function getWebmaticInformations($w3)
    {
     // Get Informations and credits about webmatic (admin side)

     // Create list content
     $_DATA = $_WIDTHS = array();
     $label = "Webmatic version";
	 $_DATA[0]->label = $label; $_DATA[0]->info = WM3_cVERSION;
     $label = "Webmatic database version";
     $_DATA[1]->label = $label; $_DATA[1]->info = WM3_cDB_VERSION." (".$w3->getDBObj()->countDBTables()." tables)";
     $label = "Webmatic database installation date";
     $_DATA[2]->label = $label; $_DATA[2]->info = wm3Util::renderDate($w3,wm3Statistic::getCounterInstallationTS($w3),$w3->getAdminLanguage());
     $label = "Webmatic database used space";
	 $size = wm3Folder::renderFileSize($w3,$w3->getDBObj()->countDBUsedSpace());
     $_DATA[3]->label = $label; $_DATA[3]->info = $size;

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(-1)."Webmatic informations");
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(30,70));
     return $list->render();
	}

  }

?>
